
История изменений

ExportToFB2.1 Version 1.0
Конвертор ExportToFB21 – это переработка и развитие конвертора ExportToFictionBook (web: http://ifolder.ru/3048108), автором которого является Thunder. Это прекрасный конвертор, с интересной идеей его реализации! К сожалению, этот конвертор, поддерживал только 2 уровня вложений заголовков. Поэтому я решил переписать его «под себя», а сначала и для себя, изменив полностью парсинг заголовков, введя возможность использование практически бесконечного числа уровней заголовков. Хотелось подогнать конвертор под формат fb2.1 как можно «ближе» и многое другое. Очень многое здесь переделано, расширено, модернизирован парсинг абзацев, сносок, введены новые алгоритмы, некоторые процедуры остались от исходного кода. Но идея и исходные коды – от Thunder`a, за что ему огромная благодарность! Я списался с ним, и он дал добро на использование его исходных кодов для создания других программных продуктов.

ExportToFB2.1 Version 1.1
1. Дополнения: В документах без единого Уровня (Заголовка) если в начале идет Эпиграф, то он не включается в <section>  (раньше – включался, хотя результирующий документ оставался валидным).
2. Исправления: В некоторый сложных структурах документа на смежных Уровнях секция не закрывалась (</section>), в результате чего fb2 документ не проходил валидацию. Теперь все работает.

ExportToFB2.1 Version 2.0
Полностью «с нуля» переписан весь парсер документа, в результате чего появились новые возможности конвертора. О них – ниже.
1. Экспорт таблиц с заголовками. В связи с разными возможностями OOo Writer 2.3 и версий ниже экспорт таблиц происходит по-разному. Для версий, ниже 2.3 таблицы экспортируются только с одним заголовком (если он есть), для версии 2.3 – со всеми заголовками, сколько их есть. Конвертор сам автоматически определяет версию OOo Writer`a, и в соответствии с этим конвертирует таблицы. Работу с таблицами в документе см. п. 4.1.
2. Экспорт текста сносок, состоящих из нескольких параграфов (вместе с форматирование). В Version 1.0 и Version 1.1 экспортировался только первый параграф каждой сноски.
3. Экспорт в нужные места тэгов картинок и их названия – в атрибут ”title” (сами картинки пока не экспортируются). Картинки могут быть 3-х видов: Привязанные к абзацу, Привязанные к символу и Привязанные как символ (Буквица). Подробности работы с картинками  см. п. 4.3..
4. Экспорт текстовых врезок (без экспорта их форматирования) как просто текста, цитат или таблицы (см. п. 4.2.).
5. Экспорт текстовых полей.

ExportToFB2.1 Version 2.1
1. Добавлена возможность указывать % жанра.
2. Изменен список жанров – выбор не в виде кода, а по названию жанра. Так удобнее.
3. Исправил обработку текстовых врезок – раньше, если попадались Линии – конвертор аварийно завершал работу.
4. Отлавливается нумерация параграфов или маркеры и экспортируется, как символ «•» перед параграфом.
5. Ввел сохранение настроек диалога «Настройки» и возможность установок «по умолчанию».
6. Ввел возможность сохранять и загружать профиль автора документа и Source OSR (кнопки «> >» и «< <» соответственно).
7. При открытии диалога экспорта профиль автора документа, если он был создан, автоматически загружается, заполняя соответствующие поля.

ExportToFB2.1 Version 2.2
1. Во всех парсерах картинок поправил название счетчика (не работал инкремент числа картинок).
2. fb2 файл теперь создается после парсинга документа, а не до, как было раньше (в случае аварийной остановки конвертора «мусор» в виде «недоделанного» файла не остается).
3. Переделана работа с нумерованным и маркированным текстом (работает и в заголовках). 
4. Дополнен тестовый файл для проверки работы с нумерацией.
5. Исправлена ошибка при записи Description – в получаемом fb2 файле не считывались данные тега <program-used>.
6. Появилась возможность пользователю задавать свои стили в соответствующем окне (см. п.3.7).
7. Исправлены мелкие недочеты, глюки.

ExportToFB2.1 Version 2.3
1. Исправление – конвертор вылетал, если последний элемент в тексте экспортируемого документа - Уровень, Эпиграф, Поэма, Цитата.
2. Расширил список жанров – взял из новой версии редактора FictionBook Editor v.2.0.
3. Новая возможность – корректировка текста (удаление лишних пробелов и табуляций, замена кавычек на «елочки», удаление «пустых» абзацев и другое) (см. п.II).

ExportToFB2.1 Version 2.4
1. Изменены типы переменных в процедурах создания элементов с Integer на Long (иначе будет ограничение на очень большие документы).
2. Исправил досадную ошибку – сохраненные настройки Диалога Настроек не считывались из файла, а брались всегда по умолчанию. Раньше настройки считывались только после захода в Диалог настроек и нажатия OK. Теперь все работает.
3. Добавлена проверку на наличие в пустых абзацах наличия форматирования bold, italic, sup и т.д. Раньше из-за этого в результирующем fb2 файле появлялись ненужные <strong></strong>, <emphasis></emphasis> и т.д., а в поэмах – вместо <stanza> — <empty-line/>.
4. Добавлены новые жанры…
5. В Корректоре текста добавлена возможность Разрыв строки заменять на 1 пробел (иногда бывает очень нужно).
6. В Корректоре текста добавлена возможность переопределять для всех картинок тип привязки. Это полезно, когда открываешь .doc документы от Microsoft Word. После открытия их в OOo Writer`е все картинки получаются привязанными, «как символ». Поэтому в Корректоре текста можно переопределять все картинки к другому типу привязки (для создания книг  достаточно или «К абзацу», или «К символу»).
7. Появилась возможность задавать ссылки-переходы внутри документа из одного места на другое (например, из стиха поэмы на аннотацию, из сноски на цитату…). Опция в Диалоге Дополнительных Настроек по умолчанию отключена. При ее задействовании и если «ссылок внутри документа» довольно много – процесс конвертации документа несколько замедляется, но оно того стоит! Подробности работы см. в п. 4.4.
8. Обновил тестовый документ ExportToFB21_Test.odt для демонстрации работы «ссылок внутри документа».

ExportToFB2.1 Version 2.4.1
1. Исправил ошибку конвертирования текста сносок. Было: Если в тексте сноски в самом конце стоит ссылка или гиперссылка, и после нее хоть один символ – все нормально конвертируется. Но, если после нее нет ни одного символа – то текст ссылки или гиперссылки в результирующем fb2-файле повторяется дважды. Например: текст сноски следующий: «Смотри Название Документа». После конвертации, вместо ожидаемого: «<p>Смотри <a l:href="#bBT" type="note">Название Документа</a></p>» получаем, к сожалению: «<p>Смотри <a l:href="#bBT" type="note">Название Документа</a><a l:href="#bBT" type="note">Название Документа</a></p>», что не есть хорошо.
Это связано с особенностями «внутренности Open Basic OOo Writer`а».
Теперь в этой ревизии конвертора это досадное недоразумение устранено.
2. Заменил кодировку сохранения fb2-документа по умолчанию с utf-8, на windows-1251, т.к. она чаще используется, и не надо делать лишних движений мышкой.
3. Обновлены справки.

ExportToFB2.1 Version 2.5
1. Оптимизировал и сделал более универсальным код работы с «Пользовательскими стилями».
2. Оптимизировал и сделал более универсальным код загрузки и сохранения настроек «Корректора Текста».
3. Оптимизировал и сделал более универсальным код загрузки и сохранения настроек для диалога «Дополнительные Настройки» конвертора.
4. Подкорректировал расположение и внешний вид контролов диалогов – на Windows они выглядят неплохо, а на Unix-подобных системах (в частности – на Ubuntu) – названия контролов «урезанные». Теперь все выглядит нормально и на Linux. Мелочь – а приятно…
5. Ввел подтверждение на загрузку данных профиля Автора fb2-документа – защита от случайного нажатия кнопки загрузки « < < ».
6. Сделано 6 виртуальных клавиатур. Подробнее см п.III
7. Обновлены справки.

ExportToFB2.1 Version 2.6
1. Ввел проверку на отсутствие расширения для экспортируемого файла, если имя и путь к fb2 файлу выбирался вручную, нажатием кнопки «…», и расширения после имени файла не было поставлено. Теперь расширение .fb2 ставится в этом случае автоматически.
2. Введена возможность сохранения и загрузки профиля для Автора Книги и его жанра.
3. Введена возможность сохранения и загрузки профиля для Издательства.
4. Введен новый раздел справки «Работа с профилями» (см.  п.8).
5. Изменена «геометрия» диалога конвертора и расположение некоторых контролов – так удобнее.
6. Новая возможность: автоматическое заполнение полей формы конвертора «Аннотация на Книгу», всех полей группы «Бумажная книга (Publish-Info)» из текста документа с помощью т.н. «Служебных стилей». Подробнее см. п.3.1.3 и п.3.6.3.
7. Внесены изменения в шаблон стилей fb21_styles.ott.
8. Существенно переделан и расширен раздел справки «3. Работа со стилями структуры документа», описывающие новые возможности конвертора при работе со стилями.
9. Внесены дополнения в тестовый файл ExportToFB21_Test.odt для возможности протестировать автоматическую загрузку выделенных «служебными стилями» Аннотации Книги и Данных на бумажную книгу и Издательство.
10. Если экспортируется Аннотация на книгу, и она состоит из нескольких абзацев, то теперь она экспортируется «как есть» – из нескольких абзацев (Раньше все абзацы аннотации на книгу соединялись вместе в один абзац).
11. Т.к. Конвертор развивается, и во всех его диалогах НОВЫЕ поля  и опции, а у пользователей УЖЕ СОХРАНЕНЫ файл стилей (styles.txt), файл Дополнительных Настроек (settings.txt), файл настроек Корректора (corrector.txt), где данных для этих новых полей и опций нет, то при работе Конвертора может произойти либо ошибка, либо экспорт выделенных новыми стилями абзацев будет сделан, как просто абзацы (<p>......</p>), что не верно; при работе Корректора может произойти либо ошибка, либо корректура произведется не так, как ожидается, а при запуске формы Корректора новые опции будут не такими, как ожидал User,
Эта потенциальная возможность некорректной работы Конвертора, Диалога Дополнительных Настроек, Корректора Текста, Диалога переопределения пользовательских настроек из-за появления новых опций и возможностей (расширяемость) устранена, что гарантирует корректность работы при «старых», не обновленных пользователем файлах настроек. Данные для новых опций будут браться по умолчанию, пока User не пересохранит соответствующий файл настроек. Тогда ВСЕ данные будут считываться из него.
12. Обновлены справки.

ExportToFB2.1 Version 2.7
1. Удалил стиль «Book Author» из-за его избыточности. Он все равно НИГДЕ не использовался, только для формирования названия книги, путем слияния его данных с данными стиля «Book Title». Поэтому, теперь для формирования заголовка книги И Автора, и Название форматируйте одним и тем же стилем «Book Title».
2. Если История fb2 файла состоит из нескольких абзацев, то теперь она так и экспортируется.
3. Удалил с основной формы конвертора поле ввода Аннотации Книги. Теперь Аннотация на Книгу считывается только из основного текста книги (так меньше путаницы).
4. Сделан экспорт форматирования Аннотации на Книгу (см. тестовый файл ExportToFB21_Test.odt).
5. Автоматическое заполнение полей-описаний Книги на главной форме при использовании «Служебных стилей» - данные на Авторов Книги (один или несколько), Переводчиков (один или несколько), Серии Книги (одна или несколько), Ключевые слова (Keywords), Дата написания Книги, все данные на Бумажную Книгу, Серии Бумажной книги (одна или несколько).
Т.е. для задания данных для описания книги вы можете использовать любой из 2-х вариантов:
а). Вообще не использовать «Служебные стили», а вручную заносить данные в соответствующие поля формы конвертора. Плюс: Нет «лишне» информации в тексте книги, которую можно забыть отформатировать «Служебными стилями», и эти данные экспортируются в текст книги fb2 формата. Минус: При повторном конвертировании уже обработанной и ранее сохраненной книги надо будет опять вводить вручную все эти данные описания книги.
б). Использовать «Служебные стили». Плюс: Все данные описания книги хранятся в тексте самой книги и не переносятся в текст книги fb2 формата, а только в тэги <Description>. При повторном конвертировании уже обработанной и ранее сохраненной книги не надо будет опять обрабатывать все эти данные описания книги. Минус: Можно по невнимательности каким-либо данным придать не тот «Служебный стиль», и эти данные не будут экспортированы в тэги раздела описания книги в fb2 формате! Поэтому будьте внимательны!
Совет: прочтите «Служебные стили» конвертора», «“Служебные стили” «по умолчанию» » и «Работа со «служебными стилями» в документе» !!!
Как выбирать Символьные (Inline) стили описано в разделе «Загрузка стилей».
Где и как располагать описание на книгу см. конец раздела справки «Дополнительные настройки».
6. При клике мышкой на метки-счетчики для Авторов Книги, Переводчиков, Авторов fb2 документа, Серии книги, Серии Бумажной книги появляется простенькое окошко-сообщение со списком – данные, занесенные в массив…
7. Новый файл стилей fb21_styles.ott.
8. Внесены дополнения в тестовый файл ExportToFB21_Test.odt для демонстрации новых возможностей экспорта данных «служебных стилей».
9. Убрано много потенциальных (при определенных условиях) ошибок работы конвертора.
10. Оптимизированы кое-где алгоритмы работы…
11. Упрощена работа со списками Авторов, Переводчиков, Custom Info и т.д.
Раньше было, если в списке уже есть данные (например, для 2-х Переводчиков), и вы ввели в поля данные на 3-го, то нужно было обязательно внести и его в список, нажав кнопку «+». Теперь это делать не обязательно. Можно: ЛИБО нажать кнопку «+», счетчик отобразит «3», поля очистятся, ЛИБО не нажимать кнопку «+», а данные так и оставить в полях. При экспорте они благополучно считаются. Эта новая возможность предохраняет случайную потерю данных…
12. Обновлены справки.

ExportToFB2.1 Version 2.8
1. Расширен экспорт Стихов (Poem). Теперь возможно экспортировать следующие элементы структуры Поэмы: необязательные элементы Заголовок, Эпиграф (с его Авторами), бесконечное число чередований обязательных элементов Подзаголовок или Четверостишие, необязательные элементы Автор стиха и Дата написания. Все это полностью реализовано в конверторе. См. тестовый файл ExportToFB21_Test.odt.
2. Расширен раздел справки «Особенности работы с текстом»  - новый раздел «Работа со стихами».
3. Новый файл стилей fb21_styles.ott.
4. Внесены дополнения в тестовый файл ExportToFB21_Test.odt для демонстрации новых возможностей экспорта элементов структуры сложной Поэмы.
5. Оптимизация кода конвертора…
6. Исправление некоторых глюков…
7. Обновлена справка.

ExportToFB2.1 Version 2.9
1. Несколько ускорен парсинг текста.
2. Сделан экспорт Сложных Цитат (чередование текста, пустых строк, сложных стихов, таблиц, подзаголовков).
3. Расширен раздел справки «Особенности работы с текстом»  - новый раздел «Работа с цитатами».
4. Новый файл стилей fb21_styles.ott.
5. Внесены дополнения в тестовый файл ExportToFB21_Test.odt для демонстрации новых возможностей экспорта элементов структуры сложной Цитаты.
6. Обновлена справка.

ExportToFB2.1 Version 2.10
1. Упрощено использование служебных стилей для выделения Названия Серии и Номера Серии и для Электронной Книги, и для Бумажной Книги:
Для этого удалены 2 служебных стиля для выделения Названия Серии Бумажной Книги и Номера Серии Бумажной Книги. Так проще (не запутаешься) – выделяешь строку Серии для Электронной Книги абзацевым стилем #Book Series, а строку Серии для Бумажной Книги абзацевым стилем #PaperBook Series, а потом для каждого вида Серии Названия выделить символьным стилем #Sequence, а Номра – #Sequence Number. Этот же принцип был ранее применен для Авторов и Переводчиков Книги. Теперь – и для Серий Книги.
2. Подкорректировал экспорт гиперссылок и ссылок внутри документа. Раньше они выглядели «приподнято», как сноски, не очень красиво для ссылок. Теперь они «не приподняты», а в рамках высоты строки – так, на мой взгляд, правильнее (убрал в коде type=”note”). Этот же подход используется и в FictionBook Editor.
3. Сделан экспорт Сложных Аннотаций (чередование текста, пустых строк, сложных стихов, сложных цитат, таблиц, подзаголовков).
4. Расширен раздел справки «Особенности работы с текстом»  – новый раздел «Работа с аннотациями».
5. Новый файл конвертора ExportToFB21.oxt.
6. Новый файл стилей fb21_styles.ott.
7. Внесены дополнения в тестовый файл ExportToFB21_Test.odt для демонстрации новых возможностей экспорта элементов структуры сложной Аннотации.
8. Обновлена справка.

ExportToFB2.1 Version 2.11
1. Сделан экспорт Сложных Эпиграфов (чередование обязательных элементов: Текст, пустые строки, сложные стихи, сложные цитаты и в конце необязательный элемент Автор Эпиграфа).
2. Расширен раздел справки «Особенности работы с текстом»  – новый раздел «Работа с эпиграфами».
3. Новый файл конвертора ExportToFB21.oxt.
4. Внесены дополнения в тестовый файл ExportToFB21_Test.odt для демонстрации новых возможностей экспорта элементов структуры сложной Эпиграфа.
5. Упрощено использование служебных стилей для работы с Поэмами:
Для этого были удалены два стиля – Poem Epigraph и Poem Epigraph Author. Теперь, каждый элемент Поэмы форматируется «своим» стилем: Эпиграф – стилем Epigraph, Автор Эпиграфа - Epigraph Author, и т.д. Так проще – не надо держать в голове разные стили…
Как правило, конвертор сам распознает один элемент от другого внутри Эпиграфа по характерным признакам (Автор или Дата Стиха, Автор Цитаты и т.д.). Но в одном случае, когда после Цитаты Эпиграфа  сразу идет Поэма конвертор «вложит» ее во внутрь Цитаты (т.к. Цитата тоже может содержать Поэму). Если же эта Поэма принадлежит не Цитате, а непосредственно Эпиграфу, то между Цитатой и этой Поэмой вставьте пустую строку стиля Текста Эпиграфа (Epigraph). Тогда Конвертор распознает и Цитату, и Поэму, как два самостоятельных элемента Эпиграфа.
Пример этого см. в тестовой файле.
6. Дополнен Корректор Текста – работа с еще одним видом кавычек…
7. Обновлена справка.

ExportToFB2.1 Version 2.12
1. В расширении теперь указывается версия и другая информация (подробнее здесь).
2. При запуске OOo Writer’a автоматически создаются панели инструментов и пункты меню для конвертора в меню Сервис (подробнее здесь).
3. Для удобства работы создан макрос (кнопка на панели конвертора, пункт в меню) для загрузки стилей в текущий документ (см. здесь и здесь).
4. Новый файл конвертора ExportToFB21.oxt.
5. Обновлена справка.

ExportToFB2.1 Version 2.13
1. Сделан экспорт текста сносок со сложными структурами – сложные стихи, сложные цитаты и т.д. Экспортируется текст сносок в виде сложных многоуровневых книг (может кому-нибудь надо – схема поддерживает это).
2. В настройках введена возможность отключения экспорта текста сносок со сложными структурами. При выборе этой опции текст сносок, содержащий сложные Цитаты, сложные Стихи и т.д, а также многоуровневый текст (как в книге главы, подглавы) ТАК И ЭКСПОРТИРУЕТСЯ в fb2-файл. Если эта опция отключена – то текст сносок со сложными структурами экспортируется ПРОСТО КАК ТЕКСТ (все в тэгах <p> … </p>).
Включение этой опции увеличивает время конвертирования.
Теперь экспорт текста сносок может быть 4-х видов (на выбор, разное время экспорта):
а). экспорт только inline-стилей (bold, italic, гиперссылка…) без экспорта абзацевых стилей (стихи, уровни…). Результат – просто текст сносок c strong…, заключенных в тэги <p>.
б). экспорт только абзацевых стилей (стихи, уровни…), без экспорта inline-стилей (bold, italic, гиперссылка…). Результат – текст сносок без strong…, со всеми имеющимися стихами, уровнями…
в). не экспортировать inline-стилей (bold, italic, гиперссылка…) и не экспортировать абзацевые стили (стихи, уровни…). Результат – просто текст сносок без strong…, заключенных в тэги <p>.
г). экспорт и inline-стилей (bold, italic, гиперссылка…) и абзацевых стилей (стихи, уровни…). Результат – текст сносок c strong…, со всеми имеющимися стихами, уровнями… Режим включен по-умолчанию.
3. В Настройках можно выбирать название секции для текста сносок в fb2-файле: Примечания, Сноски, Комментарии или вводить свое название.
4. При клике мышкой на метку-счетчик для Жанров Книги появляется простенькое окошко-сообщение со списком – данные, занесенные в массив жанров…
5. Некоторые исправления в коде…
6. Новый файл конвертора ExportToFB21.oxt.
7. Внесены дополнения в тестовый файл ExportToFB21_Test.odt для демонстрации новых возможностей экспорта сложных структур сносок.
8. Обновлена справка.

ExportToFB2.1 Version 2.14
1. Переработана функция формирования названия результирующего fb2-файла. Раньше она работала, если расширение документа было строго 3 символа после точки (“.”). В других случаях файл получался с «слипшимся» «fb2» на конце названия – без «нормального» расширения. Теперь длина расширения или ее полное отсутствие не имеют никакого значения.
2. В диалоге Настроек новая группа опций «Корректура fb2 кода»: «Убрать “пустышки” </x><x>» и «Пробелы внутри </x> <x> и <x> </x>», позволяющие в процессе конвертирования документа существенно уменьшить размер результирующего fb2 файла. Группы тэгов </strong><strong>, </sub><sub> и т.д. удаляются («пустышки»), а </strong> <strong>, </sub> <sub>, <strong> </strong>, <sub> </sub> и т.д. заменяются на пробелы.
3. Сделан FB2File Corrector (пока простой), который позволяет корректировать уже существующий fb2 файл: Убирает “пустышки” </x><x>», Заменяет Пробелы внутри </x> <x> и <x> </x>, Обрабатывает «проблемные символы» < , > , и &. Подробнее см. п.IV
4. Новый файл конвертора ExportToFB21.oxt.
5. Обновлена и расширена справка.
6. Обновлена справка.

OOoFBTools-0.01
1. Переделана структура расширения. по работе с FB2, то расширение было переименовано в OOoFBTools, и переделана ее структура.
2. В Конверторе ExportToFB21 исправлена ошибка при экспортировании документов со сложными сносками (раньше в некоторых случаях конвертор «вылетал»).
3. В Конверторе ExportToFB21 при работе с загрузкой пользовательских стилей (либо через меню, либо через использование соответствующей кнопки) введена проверка на наличие шаблона стилей fb21_styles.ott в OOo, и соответствующее сообщение при его отсутствии. Теперь загрузка стилей не завершается аварийно.
4. Переделана структура справки.

OOoFBTools-1.00
1. Теперь кодировка по умолчанию - utf-8.
2. Размеры диалогов (кроме греческой и еврейской виртуальных клавиатур) приведены к размерам, помещающимся на экране с минимальным разрешением 1024x768.
3. Заменил комбобоксы на некоторых диалогах на листбоксы.
4. Дополнения в title-info для тэга date: если никаких данных для него нет, то его не заносим в fb2 файл. Если нет атрибута value, то этот  пустой атрибут не заносится в fb2 файл.
5. Для всех форм в код добавлена установки при запуске их размеров (защита от случайного сохранения кодов из Редактора Бэйсик при включенных 3D эффектах в Linux, где форма становится урезанной и такой запускается). Теперь, при отключении 3D эффектов в Linux, размеры форм будут в соответствии с нужными размерами.
6. Пункты меню пакета вынесены из меню Сервис->Дополнения на верхний уровень в OOoFBTools. Так удобнее... При этом меню OOoFBTools видимо только для OOo Writer`а. что предотвращает случайный запуск инструментов пакета в других программах OOo и возникновение ошибок.
7. В Корректоре Текста введена проверка - если ни одна опция не выбрана - то выдается соответствующее сообщение...
8. Изменения в справке.

OOoFBTools-1.01
1. Экспорт таблиц, имеющих ячейки с несколькими абзацами. Подробнее см. пункты раздела «Работа с таблицами».
2. Атрибуты align, valign для тегов tr, th, td таблицы сделаны «не обязательными». Т.е. в Настройках конвертора их можно отключить (выбрав из списков пустое значение). В этом случае эти атрибуты в fb2 файл заноситься не будут. Это же реализовано и для «пустых» ячеек таблицы (нет ни одного абзаца), даже при выбранном выравнивании строк в Настройках. Выравнивание по ширине в любом случае «считывается» со строк таблиц автоматически.
3. Символьное форматирование слов строк таблиц (strong, sub…) пока отключено (все равно оно работало не правильно).
4. Обновлен тестовый файл ExportToFB21_Test.odt для демонстрации новых возможностей экспорта таблиц.
5. Исправлен трудноуловимый глюк – в некоторых случаях при работе с таблицами следующий сразу же после таблицы уровень (заголовок) «становился» просто текстом, структура нарушалась. Теперь все работает корректно.
6. Изменения в справке. Увеличен пункт «Работа с таблицами».

OOoFBTools-1.02
1. Добавлена защита от ошибочного названия закладки для формирования ссылок и переходов внутри документа. Согласно схеме fb2, id элемента, на который ссылается ссылка не должен начинаться с цифры. Например, книга со строкой: <p id=”01”> Текст</p> - не будет валидной. Когда в OOo Writere вставляются закладки для определения ссылок, то кто-то может об этом забыть (или не знать), и ввести имя закладки вместо “ch01”, “_01” и т.д. просто “01” и т.д. Это же относится и к уже «готовым» документам, где уже кем-то сформированы гиперссылки – переходы внутри данного документа (мне такие файлы встречались сотни раз – особенно html-ные). Поэтому в конвертор и введена защита: каждому имени закладки-ссылки с начала добавляется символ ”_”.
2. Устранена ошибка при конвертировании текстовых сносок (не всегда корректно они определялись, и конвертор «вылетал» на формулах).
3. Поправил баг: в FB2Corrector при нажатии кнопки выбора файла макрос "вылетал". Теперь все работает.
4. Для сохранения и загрузки профиля Автора Книги добавил сохранение и загрузку языка создаваемой книги в fb2 и языка оригинала. Так удобней.
5. Все профили (Автора Книги, Автора fb2 файла, Издательства, настройки конвертора, настройки Корректора Текста, настройки Пользовательских Стилей) теперь сохраняются и считываются в utf-8 кодировке, что позволяет работать с символами Unicode. С другой стороны, это «задел» на будущую локализацию пакета инструментов OOoFBTools.
6. В Корректоре Текста расширена обработка лишних пустых пробелов. Теперь удаляются и все лишние «неразрывные пробелы».
7. Атрибут match тэга genre сделан по умолчанию необязательным, как и задано в схеме FictionBook. Т.е. в контроле match по умолчанию стоит 0. В этом случае этот атрибут не заносится в тэг genre. Если же значение счетчика match изменится, и станет больше 0, то это значение будет добавлено, как значение атрибута match тэга genre.
8. На основной форме диалога конвертора сделан режим выбора схемы жанров: FictionBook 2.1 или FictionBook 2.2. В зависимости от выбора схемы жанров меняется и выпадающий список жанров.
9. В диалоге Определения пользовательских стилей добавлены две кнопки: «Загрузить профиль…» и «Сохранить профиль…».
Часто работаешь с уже «готовыми», т.е. отформатированными стилями документами. Можно вручную в тексте документа заменять эти стили на fb2 стили «по умолчанию». Можно в этом диалоге переопределить эти стили на «ваши». А можно сделать еще проще и удобнее: сделать разные профили стилей для разных типов документов, уже отформатированных «своими» стилями – для Microsoft Word, для html файлов и т.д. Когда открываешь определенный документ, просто загружаешь для него «его родные» стили, и все!
10. Ввел в файл стилей fb21_styles.ott символьный тэг code (выбирается в окне стилей «стили и форматирование») на вкладке «символьные стили», режима «Стили пользователя».  Внешний вид стиля можно перестроить. Название этого стиля  задано жестко – изменить нельзя – конвертор не воспримет другое название. Для конвертирования текста в «code» теперь используются 3 варианта: выделение его Тенью, Контуром или новым символьным стилем «code». Эта новая возможность добавлена для тех, кому легче работать и помнить «осмысленные» названия стилей.
11. В экспорт таблиц введена возможность конвертирования многоабзацевой ячейки в один абзац (все абзацы ЭТОЙ ячейки сливаются через пробел). Для этого надо «заблокировать» нужную ячейку: клик правой клавишей мышки на нужной ячейке, выбираем Ячейка -> Защищено. Подробнее см. «Ячейки: экспорт абзацев, как строк и экспорт абзацев как одну строку»
12. Исправил баг в работе с текстовыми врезками – если после нее сразу шел Уровень (секция), то она не воспринималась как секция, а просто текст. Что иногда приводила к невалидности результирующего fb2 файла. Исправлено.
13. Тоже самое и для экспорта тэгов картинок.
14. Полностью переделан тестовый файл ExportToFB21_test.odt. Он разбит на 2 файла: ExportToFB21_test-1.odt. – демонстрация основных возможностей конвертера и ExportToFB21_test-2.odt. демонстрация экспорта маркированных и нумерованных структур.
15. Обновлена справка.

OOoFBTools-1.03
1. Добавлена защита от некорректного экспорта: Если включена опция "Удаление пустых строк" и пустая строка находится между смежными Уровнями одного ранга ИЛИ смежными Уровнями с большего на меньший ранг, то пустая строка остается. Иначе fb2 файл не будет валидным.
2. Добавлена защита от некорректного экспорта: Если есть Стартовая Аннотация ДО 1-го Уровня, и после нее ничего нет, а идет сразу Уровень (Часть, Раздел, Глава Книги), то – книга получалась невалидной. Исправлено - вставка пустой строки после ТАКОЙ СТАРТОВОЙ Аннотации для валидности книги.
3. Введена проверка на наличие «пустого» Жанра и «пустого» Названия Книги (а то, если был пробел – он экспортировался, как название книги). Исправлено.
4. Сделан экспорт сложных таблиц некоторого вида (см. здесь и здесь).
5. Для простоты работы с Жанрами сделан список Избранных Жанров (см. здесь).
6. В Корректоре текста появилась полезнейшая опция: «Собрать разорванные символом ¶ строки абзаца в один абзац». Часто «работаешь» с книгами, скаченными из сети, которые после OCR сохранялись, как простой текст. Красная строка «отбивалась», как несколько пробелов, а перевод строки сохранялся как окончание абзаца. Т.е. все строки каждого абзаца сохранились, как отдельный абзац. Править руками такую книгу удовольствия мало… Корректор позволяет собрать такие строки в «нормальные» абзацы. При этом идентификатором «нового» абзаца является наличие в начале строки 1 или нескольких пробелов  (Подробнее и картинки примера см. здесь).
7. Разные изменения, улучшения алгоритмов…
8. Обновлен тестовый файл ExportToFB21_test-1.odt.
9. Обновлена справка.
OOoFBTools-1.0.4
1. Исправлена ошибка в парсере таблиц (убрана лишняя скобка).
2. В Корректор Текста добавлена новая опция: «Удалить мягкие переносы».
3. В Корректоре Текста для опции  «Собрать разорванные символом ¶ строки абзаца в один абзац» сделано 2 режима склейки строк абзаца: 1-й – «По пробелам вначале абзаца» (из OOoFBTools-1.03) и 2-й – «По .!?…»”\"":; в конце абзаца», т.е. завершение абзаца определяется по выше названным символам, а все абзацы между – воспринимаются, как разорванные строки одного и того же абзаца, и склеиваются (картинки примера работы Корректора см. здесь).
4. Дополнена справка.

OOoFBTools-1.0.5
1. Исправил серьезную ошибку: По схеме FictionBook, если нет данных на Автора Книги или Автора fb2-файла, то тэги для Автора все равно должны присутствовать в секции Description в виде:
<author>
	<first-name/>
	<last-name/>
</author>
или
<author>
	<nickname/>
</author>
К сожалению, до настоящей версии конвертора, если Автора Книги или fb2-файла не было, то эти обязательные тэги вообще не записывались в файл (давно не заглядывал в схему, а память стала подводить ?). Книга получалась невалидной. Теперь это исправлено!
2. Сделана масса исправлений и улучшений конвертера для экспорта сложных структур: Эпиграфов, Аннотаций и т.д.
3. В ряде случаев получаемый fb2-файл не проходил валидацию – не соответствовал схеме. Исправлено.
4. Для текста сносок сделана корректная обработка сложных структур Уровней, Аннотаций и Эпиграфов – соответствие схеме. Ранее не всегда сложных структур текста сносок экспорт проходил корректно (все случаи трудно предусмотреть).
5. В Корректор Текста добавлена новая опция: «Удалить разрывы для дефисов и переносов слов» с 3-мя вариантами работы. Очень нужная и полезная опция! Поиск и корректура осуществляется везде – в тексте, в таблицах, в текстовых врезках и в сносках. Подробнее см. здесь.
6. В Корректоре Текста улучшена работа опции  «Собрать разорванные символом ¶ строки абзаца в один абзац». Теперь перед сборкой разорванных строк одного абзаца в «свой» абзац Корректор сначала удаляет все мягкие переносы (даже если опция выключена) и удаляет все разрывы дефисов и слов – новая опция (даже если опция отключена). Это обеспечивает корректную «склейку» строк абзацев.
7. Сделаны два новых инструмента для ручного поиска: 1. Поиск слов с дефисами. 2 Поиск слов с разорванным переносом. При нажатии на соответствующие кнопки панели инструментов или выборе пункта из меню OOoFBTools нужные слова выделяются в тексте. Удобно подвесить эти инструменты на «быстрые клавиши». Поиск осуществляется везде – в тексте, в таблицах, в текстовых врезках и в сносках.
8. Дополнена и расширена справка для Корректора Текста.

OOoFBTools-1.0.5.1
1. Исправил ошибки в функциях обработки таблиц – не были объявлены переменные. Конвертор вылетал. Исправлено.

OOoFBTools-1.1.0
1. Часто, после экспорта текста, полученного после распознавания FineReader`ом, на прямой речи первые два символа абзаца дублировались дважды. Это теперь исправлено (надеюсь – проверить не на чем.).
2. Экспорт выравнивания каждого абзаца для каждой ячейки и простых и сложных таблиц. Т.е., если в ячейки 3 абзаца, и 1-й выровнен «по левой стороне», 2-й – «по правой», а 3-й – «по центру», то именно это выравнивание и будет экспортировано.
3. Экспорт форматирования стилями (полужирный, курсив и т.д.) для каждого слова каждого абзаца ячейки и простой и сложной таблицы.
4. Экспорт гиперссылок из текста и простой и сложной таблицы.
5. Экспорт переходов из любого слова  таблицы на любое место документа  и простой и сложной таблицы.
6. Экспорт сносок для любого места и простой и сложной таблицы.
7. Экспорт таблиц в составе Аннотаций и Цитат, как частей Аннотаций и Цитат соответственно.
8. Экспорт нумерованных списков в Таблицах (абзацы ячейки в виде нумерованного списка). Экспорт маркированных списков в ячейке пока не сделан.
9. Два режима экспорта символьных стилей (курсив, полужирный…) для слов: 1). «Только один стиль (по приоритету)», и 2). «Все символьные стили». Выбор – в диалоге Настроек.
При режиме «Только один стиль (по приоритету)» слово, отформатированное сразу несколькими символьными стилями (гиперссылкой, полужирным и курсивом и т.д.) экспортируется только с одним стилем, причем стиль выбирается согласно списка приоритета стилей: HyperLink, <strong>, <emphasis>, <sup>, <sub>, <code>, <strikethrough>. Одновременно "пометить" слово или фразу несколькими тэгами (например <strong><emphasis><code>пример</code></emphasis> текста с <emphasis>множественным</emphasis> стилем<strong>) нельзя. Этот режим работает быстрее.
Например, есть такой текст:
Пример экспортируемого текста.
После экспорта fb2-код будет для этого режима таким:
<p><strong>Пример </strong><a l:href="http://www.google.ru/">экспортируемого</a><strong> текста.</strong></p>

При режиме «Все символьные стили» слово, отформатированное сразу несколькими символьными стилями (гиперссылкой, полужирным и курсивом и т.д.) так и экспортируется – со всеми стилями.
Например, все для того же текста:
Пример экспортируемого текста.
Результат будет уже другой:
<p><strong>Пример </strong><sup><emphasis><strong><a l:href="http://www.google.ru/">экспортируемого</a></strong></emphasis></sup><strong> текста.</strong></p>
Для сравнения – код, приведенный ниже, сформирован в редакторе FictionBook Editor:
<p><strong>Пример </strong><a l:href="http://www.google.ru/"><strong><emphasis><sup>экспортируемого</sup></emphasis></strong></a><strong> текста.</strong></p>
Этот режим включен по-умолчанию.

10. Экспорт для Текстовых Врезок сделан полностью: учитывается опция «Удаление пустых абзацев», экспортируются символьные стили для слов Врезок (гиперссылка, переход на другое место документа, курсив, верхний регистр …). Работает выбор режима экспорта символьных стилей.
Для Текстовых Врезок сделано 4 режима экспорта: 1. Таблица, 2. Текст, 3. Цитата, 4. Структура. Первые три режима позволяют конвертировать текст врезки соответственно в виде Таблицы, Текста и Цитаты. При этом Абзацевые стили (Поэма, Цитата…) игнорируются. Для режима «Таблица» при экспорте учитывается выравнивание абзацев Врезки по ширине. 4-й режим – для конвертации Врезки в виде Структуры. Работают все стили Абзацев! Т.е. текст после соответствующего «обрамления» стилями можно экспортировать, как Цитаты, Сложные Стихи, Уровни (Заголовки), Подзаголовки…
Совет: В 4-м режиме будьте очень внимательны! Если врезка – не в начале документа, и текст оформлен, как Аннотация или Эпиграф – книга будет невалидной! Поэтому, этот режим лучше все использовать для экспорта Сложных Стихов. Цитат, Подзаголовков, Заголовков (Уровней)… Хотя для этого удобнее вообще не пользоваться Врезками…
11. Экспорт нумерованных списков в Текстовых Врезках. Экспорт маркированных списков во Врезке пока не сделан.
11. Дополнил тестовые файлы ExportToFB21_Test-1.odt и ExportToFB21_Test-2.odt для демонстрации всего вышеназванного.
12. Кнопка «About OOoFBTools …» и пункт меню «About OOoFBTools …» в Группе меню «OOoFBTools». Простое окно с информацией о назначении пакета OOoFBTools, текущей версии, года создания и разработчиках…
13. Мелкие доделки и улучшения…
14. Обновлена справка.

OOoFBTools-1.1.1
1. Сделан экспорт тэгов Картинок из Таблиц. Распознается привязка Картинок только как «К символу» и «Как символ». Другие – игнорируются и тэг Картинки не будет экспортирован!
2. Сделан экспорт тэгов Картинок для Текстовых Врезок. Распознается привязка Картинок только как «К символу» и «Как символ». Другие – игнорируются и тэг Картинки не будет экспортирован!
3. Сделан экспорт Таблиц для Текстовых Врезок.
Вложенные Врезки во Врезки не экспортируются (слишком сложно разрабатывать алгоритм, да и не нужно это)!
4. Улучшен экспорт сложных Поэм. Поставлена «защита от глупости», когда первой строкой Поэмы идет пустой абзац со стилем Поэмы. Схема fb2 это «не переваривает».
5. Исправил экспорт тэгов <th/> и <td/> для Таблиц для «виртуальных» строк. Было – независимо от того, чем являются смежные ячейки – заголовком или данными, всегда экспортировался тэг <th/>. Теперь – для Заголовков Таблиц – <th/>, для данных – <td/>
6. Дополнил тестовые файлы ExportToFB21_Test-1.odt и ExportToFB21_Test-2.odt для демонстрации всего вышеназванного.
7. Мелкие, но жизненно важные доделки и улучшения…
8. Обновлена справка.

OOoFBTools-1.1.2
1. В Корректоре Текста введена более корректная обработка дефисов, тире, кавычек и пробелов – с учетом множества пробелов между словами и прямой речи (- в начале абзаца).
2. Для парсеров Таблиц и Врезок исправил ряд ошибок и внес улучшения.
3. Новая опция в Настройках – «Запустить созданный fb2-файл (Просмотр)». Она позволяет запустить созданный fb2-файл в приложении, которое ассоциировано с расширением fb2. Если fb2 файлы запускает по-умолчанию читалка – то она и запустится, если – FB2 редактор – то он и запустится, если xml-редактор, то он и запустится. Если с fb2 не ассоциирована никакая из этих программ, то запустится текстовый редактор, либо браузер, в зависимости от настроек системы. Эта опция удобна тем, что можно сразу после экспорта текста просмотреть, что же у нас получилось. Опция по-умолчанию включена.
4. Новая опция в Настройках – «Валидация созданного fb2-файла». Она позволяет после создания fb2-файла проверить его на соответствие схеме FictionBook.xsd. Опция по-умолчанию включена. Пока валидация работает только для системы Windows.
5. Новый инструмент – Валидатор fb2-файлов. Диалог с выбором нужного файла. Работает пока только для Windows. Описание см в п. Валидаторы данной справки.
6. Сделана корректная обработка нумерованных и маркированных списков для Текста Книги, Текстовых Врезок и Таблиц. Все работает, но для маркеров берется маркер только из 1-го уровня. Т.е., если есть маркированный список из нескольких уровней, и на разных уровнях –  разные маркеры, то для всего списка будет использоваться маркер 1-го уровня.
7. Исправлена ошибка экспорта «прямой речи» из текста, распознанного FineReader`ом. Часто FineReader распознает несколько идущих подряд абзацев с прямой речью (абзац начинается с «–») как маркированный список. Раньше конвертор не умел распознавать маркированные списки, и прямая речь просто «исчезала» при экспорте. Теперь все экспортируется корректно.
8. В расширение помешена папка «fb2-schema» с fb2-схемами (нужны для работы валидатора).
9. Переделан диалог About.
10. Обновлена справка.

OOoFBTools-1.1.3
1. Немного исправлены стили в файле стилей fb21_styles.ott – межстрочный интервал, размер шрифта. Получилось удобнее (на мой взгляд).
2. Переправил в Греческой клавиатуре клавишу с Greek Small Letter Omega With Varia (по ошибке она печатала "не свой" символ, а Greek Small Letter Omega With Oxia).
3. Для экспорта полей раздела Description введена обработка «проблемных» символов (<, > и &). 
4. Устранил ошибку в работе с Избранными Жанрами.
5. Новая кнопка «new ID» рядом с полем Id Книги на главной форме конвертера – генерация ID книги.
6. Масса улучшений, «интеллектуальных» функций интерактивного общения конвертера с пользователем, устранение мелких ошибок…
7. Только для Linux и других Unix-подобный систем:
а). Экспорт Картинок всех форматов, понимаемых OOo из Текста документа, из Текстовых врезок и из ячеек Таблиц.
б). Экспорт Формул из Текста документа, из Текстовых врезок и из ячеек Таблиц.
в). Экспорт Диаграмм из Текста документа, из Текстовых врезок и из ячеек Таблиц.
8). Возможность экспорта картинок разных форматов. Предварительно перекодировав их в «родные» для fb2-читалки (этим занимается конвертер автоматически). В диалоге Настроек конвертера – новые опции для выбора «на ваш вкус» в какой формат будет осуществлено предварительное преобразование каких графических форматов, в том числе и Формул и Диаграмм. Подробнее см. п.11 в  6.2. Дополнительные настройки а так же 4.3.1. Допустимые виды графики (Картинки, Формулы, Диаграммы) !!!!!!
9. Внесены изменения в тестовый файл ExportToFB21_Test-1.odt для демонстрации экспорта Графики и Обложки.
10. Внесены дополнения в справку:
2.4. Установка дополнительных платформозависящих пакетов и приложений
1.2.3. Дополнительные возможности (к «Что реализовано»)
4.1.10. Экспорт Графики (Картинки, Формулы и Диаграммы) из ячеек Таблицы
4.2.2. Возможности (Для Текстовых Врезок)
4.3.1. Допустимые виды графики (Картинки, Формулы, Диаграммы)
4.3.5. Обложки Книги
4.3.6. Особенности работы с Графикой для Unix-подобных систем
6.2. Дополнительные настройки
Планы по развитию пакета OOoFBTools (TODO)

OOoFBTools-1.1.4
Для пользователей Windows:
1. Сделан экспорт Картинок, Формул и Диаграмм из Текста Документа, из Текстовых Врезок и из Ячеек таблиц. Ничего дополнительного устанавливать не надо.
Для все систем:
1. В диалоге Настроек появилась новая опция «Экспортировать Графические Объекты», которая позволяет либо включить экспорт картинок, формул и диаграмм, либо отключить их экспорт, а оставить экспорт только их тэгов. Это сделано для того, что не на всех операционных системах OOo или производные от него редакторы (как на Mac Os X) может вести себя одинаково при преобразовании графики. И, если вдруг на вашей системе конвертор будет «слетать» при экспорте графики – просто пока отключите эту опцию – картинок в fb2-файле не будет, зато все остальные «изыски» конвертора будут работать.
2. Переделаны "служебные стили" - с ними стало более удобнее и информативнее работать. Появились новые абзацевые и символьные стили для Жанра Книги и Языка Книги.
3. Новый файл fb21_styles.ott с новыми служебными стилями.
4. Сделано 2 новых инструмента для работы со служебными стилями - вставка 1 или нескольких Жанров и Языка Книги. Эти инструменты не позволяют ввести ошибочные данные в "служебную область" описания Книги. Иначе конвертор просто проигнорирует неверный Жанр или Язык и он не будет экспортирован, чтобы fb2-файл остался валидным.
Доступ к этим инструментам - через соответствующие кнопки (Insert Description Genre… или Insert Description Lang…) на панели инструментов FictionBook Tools или через меню OooFBTools.
5. Существенно изменены разделы справки "3.1.3. «Служебные стили» конвертора" и "3.6.3. Работа со «служебными стилями» в документе". Прочитайте их целиком!
6. Обновлены тестовые файлы ExportToFB21_Test-1.odt и ExportToFB21_Test-2.odt для демонстрации работы новых "служебных стилей".
7. Из файла справки история изменения пакета вынесена в отдельный файл ChangeLog.txt. так удобнее - справка не разрастается второстепенной информацией.
8. Исправил глюк в парсере Нумерованных списков. В некоторых случаях, когда строка такого списка начиналась словом с полужирным выделением, парсер неверно анализировал данные и "портил" тэги <strong> - результирующий fb2-файл получался невалидным. Исправлено.
9. В Корректоре Текста сделана новая опция - Удаление разрывов страниц. Полезна при обработке текста после OCR.
ВНИМАНИЕ: У OOo есть две неприятные особенности (остались и в 3-й версии) по работе с графикой:
	1. Если работа любого макроса или любого установленного расширения была аварийно остановлена (макрос "слетел"), то лучше перезагрузите OOo Writer редактор, и только потом делайте экспорт книги! Иначе OOo не корректно сохраняет картинку в файл ("уродуя" ее до нескольких байт - даже в просмотрщике не откроете - ошибка), и при экспорте книги вместо mime-кода картинки будет всего несколько байт - картинки не будут "читатся" читалками (оно и понятно). Будьте внимательны с этим! Я буду разбираться, как можно обойти все это, но пока - другого пути нет - перезагружайте редактор в случае сбоя ЛЮБОГО МАКРОСА!!!
	2. Когда Графика имеет большое DPI и (или) размеры (ширина x высота в точках), то при многократном экспорте книги с такими картинками OOo одну и ту же картинку преобразует в файл по-разному (определяет разный тип графики и может вести себя, как описано выше - сохранять "порченную" картинку в файл из нескольких байт). Результат экспорта такой книги - как и вышеописанный. Поэтому: чем меньше DPI - тем лучше (более 96 смысл не имеет делать) и чем меньше точек у картинки по ширине и высоте - тем лучше!!!
	
OOoFBTools-1.1.4.1
1. Для инструмента вставки Жанра Книги в Служебную область сделана возможность работы с Избранными Жанрами.
2. Исправлено определение системы: Windows, Mac OS X, Linux и т.д. Это влияло на корректную работу конвертора и экспор Графики.
3. Изменения в справке.
4. Обязательно прочтите раздел Справки "4.3.7. Условия успешного экспорта Графики" !!!!!!!!!!!!!!!!!!!!!!!!!!
Для пользователей Mac OS X:
5. Исправлен глюк - вылет конвертора при экспорте Графики (Теоритически - Протестировать не на чем :-) )

OOoFBTools-1.1.5
1. Переделал алгоритм обработки Графики. Теперь конвертор экспортирует помимо Формул и Диаграмм еще и Картинки 2-х видов: "внедренные" в документ, и вставленные в документ, как ссылки, т.е. сами Картинки лежат где-нибудь в папке на диске (например html-файл и т.д.).
2. Исправил серьезную ошибку в обработке таблиц. В некоторых случаях в ячейке может быть другая таблица (часто это встречается в html-файлах или в файла, созданных на основе этих html-файлов). На таких ячейках конвертор "падал". С другой стороны, не все сложные таблицы конвертор может экспортировать (см. справку). Поэтому, встречая такие ячейки, конвертор экспортирует ее данные ДО таблицы в ней. Эту встроенную в ячейку таблицу конвертор игнорирует. Это лучше, чем падение конвертора и не получение fb2-файла.
3. Внесены изменения в тэстовый файл ExportToFB21_Test-1.odt для иллюстрации того, что сложные таблицы с таблицей в их ячейке экспортируются без этой самой вставленной в ячейку таблицы.
4. Внесены изменения в парсер таблиц. Раньше было: в некоторых случаях таблицы экспортировались в порядке их вставки в документ. Например, 1-я таблица вставлена в начало документа, 2-я - в конец, 3-я - в середину. В результате в fb2-файле таблицы могли идти по-порядку: 1, 2, 3, а не как ожидалось: 1, 3, 2. Чтобы добиться правильного следования таблиц в fb2-файле нужно было последовательно вставлять их в документ. А это не всегда удобно при корректуре и доработке документов.
Теперь, после изменения алгоритма парсера таблицы можно вставлять в документ в любом порядке, и именно в порядке их следования они и будут экспортированы, как и ожидается.
5. Переделана обработка Маркерных и Нумерованных Списков. По мере развития OOo.org многие объекты, их методы и свойства меняются, удаляются или расширяются. Это приводит к тому, что на более новых версиях OOo.org конвертор может не работать или работать некорректно. Так получилось с Нумерованными Списками в новой версии Ooo.org 3.
Переделал всю обработку таких списков - более универсальный алгоритм. Теперь экспорт Маркерных и Нумерованных Списков будет работать на всех версиях OOo.org.
6. Сделан экспорт для Маркеров-Картинок. Теперь у Маркера картинка не заменяется символом •, а экспортируется именно картинка.
7. Доделан экспорт Нумерованных и Маркерных Списков (и Маркеров-Картинок) для ячеек Таблиц.
8. Внесены изменения в тэстовый файл ExportToFB21_Test-2.odt - Маркеры и Нумерованные списки.
9. Изменения в справке... В разделе 2.4. Установка дополнительных платформозависящих пакетов и приложений добавил раздел 2.4.2. Для системы Mac Os X и дополнения в других разделах.
Для пользователей Mac Os X:
10. Сделан экспорт Графики: Формулы, Диаграммы, Внедренные в Текст Картинкии ссылки на Картинки в тексте (Опять, теоритически, должно работать, проверьте на Маке...). 

OOoFBTools-1.1.5.1
1. Подправил экспорт Графики для Mac Os X

OOoFBTools-1.2.0
1. Улучшения в Корректоре Текста - поиск разорванных абзацем переносов и фефисов. Ряд других улучшений...
2. Удалены 2 ручных инструмента поиска ошибок OCR в тексте из-за создания нового (см. ниже).
3. Новый диалог поиска OCR ошибок - 4 ручных инструмента "под одной крышей": 1). Поиск слов с дефисами, тире или минусом. 2). Поиск слов, в которых абзац разорвал перенос (дефис, тире или минус). 3). Поиск обрыва предложения на словах, знаках препинания, кавычках и скобках. 4). Поиск вероятного недостающего пробела между словами.
Диалог - немодальный - удобно редактировать найденное, не закрывая диалог. Запоминавет свое положение на экране. Подробности и описание см. в справке: II.2. «Ручные» инструменты.
4. Локализация меню пакета и всех панелей инструментов (пока только русский и английский языки).
5. Набор новых инструментов для работы со сносками: 1). Генерация сносок по шаблону (текст в скобках и т.д., по выбору). 2). Генерация сносок по номерам примечаний (согласно шаблона): а). Списки примечаний находятся после главы книги. б). Списки примечаний находятся в конце книги. 3. Преобразование номеров примечаний (цифр) в верхнем индексе в один из шаблонных видов, для дальнейшего использования одного из вышненазванных инструментов. 4. Инструменты вставки закладок поиска примечаний и удаления этих закладок.
Подробнее см. в справке: "II.6. Инструменты работы с примечаниями и сносками"
6. Все виртуальные клавиатуры сделаны немодальными (теперь можно редактировать текст, не закрывая их).
7. Все диалоги пакета теперь запоминают свое положение на экране. Так удобнее.
8. Исправлена серьезная ошибка в Конверторе - если Заголовки (Уровни) имеют 2 или более строки, и в последней есть сноска - то файл получался невалидным. Теперь это исправлено.
9. Исправлена серьезная ошибка - если в тексте есть закладка на несколько абзацев, то при конвертировании имя этой закладки вписывалось в id для каждого из этих абзацев. Файл получался невалидным - одинаковые id в p. Теперь одинаковые id игнорируются.
10. Обновлена справка.

OOoFBTools-1.2.1
1. Удалил из пакета FB2Corrector (ранее был заблокировн), по 2-м причинам: 1) Не доработан. 2) Уже есть прекраснейшая утилита FB2Fix (написана на C#, на Линуксе идет под Моно).
2. Улучшения в работе со "служебными стилями".
3. Исправления в основном парсере - на некоторой векторной графике конвертор "падал". Исправлено.
4. Новая опция в Настройках - "сохранить fb2-файл в utf-8, если в тексте есть маркеры". Опция по-умолчанию включена. 
Теперь, даже при выбраннок кодировке windows-1251, при включенной этой опции и наличии маркеров они не будут экспортированы, как ?, а корректно.
5. Теперь для экспорта графики не требуется скрипт .OOoFBTools-mef.sh в пользовательской папке для Unix-подобных систем!
6. Пакет "не падает" на OOoWriter 3.
7. Внесены изменения в справку.

OOoFBTools-1.3.0
1. Локализация всего пакета на русский и английский языки.
2. При запуске основной формы конвертера Язык Книги в соответствующем выпадающем списке автоматически устанавливается соответственно языку по-умолчанию в системе. Для русских - ru, для англоговорящих - en и т.д.
3. Значительно улучшены ручные инструмента поиска OCR-ошибок в Тексте. Появилась возможность нажатием одной кнопки на диалоге поиска вносить корректуру в найденных текст, не переходя в сам текст. Удобно... Сделан интеллектуальный режим и "защиты от глупости", хотя все не предусмотришь...
Обращайте внимание (hint) на подсказки на кнопке коррекции!
Подробнее см. справку.
4. Внесены изменения в справку.
5. Мелкие изменения и улучшения...

OOoFBTools-1.3.1
1. Исправлена серьезная ошибка-опечатка в Корректоре Текста.
2. Изменения в инициализации локализации Конвертера - она вынесена из подпрограммы запуска диалога в подпрограмму старта Конвертора. Теперь сообщения о несохраненном или измененном документе и другие отображаются...
3. Устранена серьезная ошибка в парсере таблиц. Если в документе в ячейке таблицы есть разрыв строки, то fb2-файл получался невалидным - не было в этих строках либо открывающих тэгов <th>, <td>, либо закрывающих тэгов </th>, </td>. Эта проблема чаще всего встречалась при экспорте html-страничек, где в ячейках таблиц много <BR>.
Теперь это исправлено, все корректно экспортируется (надеюсь :-) ).

OOoFBTools-1.3.2
1. Исправления багов в работе с Избранными Жанрами.
2. Переписал код удаления лишних "пустых" абзацев для Корректора Текста - в OpenOffice.org версии 3 перестал работать стандартный код на таблицах - наглухо вешался редактор! Переписал код - теперь все работает.
3. Переделан генератор примечаний в сноски. Вместо 2-х режимов для сложной генерации сносок стало 3:
1). Нумерация примечаний в Тексте – сквозная; Общий Список примечаний – в конце книги.
2). Список примечаний – после каждой главы книги.
3). Все списки примечаний – в конце книги.
Так - информативнее и понятнее. См. справку.
4. В генераторе сносок убрана обработка таблиц. И таблицы и Врезки просто игнорируются (из-за некорректного результата).
5. Раньше, если генератор встречал "пустые" номера примечаний в Тексте. то он преобразовывал их в сноски с "пустым" текстом. А это могли быть не номера примечаний, а, например. чило лет в скобках. Теперь, если не найдено соответствие между номером в тексте и номером в Списке примечаний - чего-то нет - то этот номер не преобразовывается в сноску. Так логичнее, и не искажается текст книги.
6. Новое в генераторе сносок - Тест. Теперь перед генерацией можно протестировать книгу и изучить сгенерированный отчет в браузере на наличие ошибок в тексте. Подробнее см. Справку.
Тест работает ПОКА только для Режима: Нумерация примечаний в Тексте – сквозная; Общий Список примечаний – в конце книги. Для остальных режимов - в следующем релизе пакета.
7. Расширил и внес изменения в справку.

OOoFBTools-1.3.3
1. В Корректоре Текста ввел Защиту от невнимательности: ВСЕГДА при запуске диалога опция склейки строк в параграф ОТКЛЮЧЕНА - ее можно при желании включить и запустить корректировку.
Это сделано для того, чтобы при очередном запуске Корректора по-забывчивости не отключив эту опцию там, где она не нужна - не загубить документ.
Иными словами состояние этой опции не запоминается, а включается всякий раз, когда это нужно, руками.
2. Сделан Тест для всех 3-х режимов Генерации сносок:
1). Нумерация примечаний в Тексте – сквозная; Общий Список примечаний – в конце книги.
2). Список примечаний – после каждой главы книги.
3). Все списки примечаний – в конце книги.
Теперь перед генерацией сносок из примечаний легко увидеть, есть ли в книге ошибки в нумерации примечаний, и будет ли генерация корректа.
См. подробнее с массой примеров работы Теста в Справке.
4. Переписал код для вставки закладок для Главы книги и Списка ее примечаний с учетом всевозможных ситуаций, когда закладки могут накладываться друг на друга и т.д., что недопустимо.
5. Внес дополнения в справку.

OOoFBTools-1.3.4
1. Исправлена серьезная ошибка в Конверторе:
Если в тексте и (или) сноске есть обрыв строки (<BR> в html текстах), то в результате экспорта fb2-файл получался в некоторых слкучаях при форматной строке (курсив, болд...) невалидным.
Исправлено. Теперь, разрыв строки в тексте и в сноске заменяется на пробел.

OOoFBTools-1.3.5
1. Ввел интеллектуализацию в Конвертере для экспорта Description - предотвращение некоторых возможных ошибок при невнимательности пользователя.
2. Новый инструмент для Вычитки Текста - Очистка форматирования абзаца. Сбрасывает стиль абзаца, где стоит курсор в "Базовый". Мне это очень часто требуется при вычитке и форматирования fb2-стилями - внешний вид абзаца начинает соответствовать fb2-стилям.

OOoFBTools-1.3.6
1. В Корректоре Текста при обработки разорванных абзацем переносов (слов с минусом, тире или дефисом) добавлена обработка еще и неразрывного дефиса.
2. В Корректоре Текста при замене минусов в словах "кое-кто", "во-первых" и т.д. добавлена обработка еще и неразрывного дефиса.
3. В инструменте "Поиске OCR ошибок в тексте" ввел обработку еще и неразрывного дефиса.
4. В инструменте "Поиске OCR ошибок в тексте" для поиска слов с дефисами, тире или минусами ввел две кнопки: 1-я - для Запоминания найденного (выделенного курсором) "хорошего" дефисного слова; 2-я - для открытия файла списка дефисных слов для его редактирования (если случайно "запомнили" не то слово).
а). Сделаны защиты от запоминания случайно выделенных не дефисных слов, нескольких абзацев или при отсутствии выделения в тексте.
5. Дополнение в Справке в ее части, касаемой Ручных инструментов вычитки текста.
6. Исправлен баг при конвертировании некоторых видов картинок - конвертор вылетал. Исправлено. Работает и на OOo2, и на OOo3.
7. Ввел новый раздел Справки - Вопросы и Ответы, куда собираю основные вопросы по разным видам (картинки, таблицы, валидность файла и т.д.).Это - ответы, почему что-то не работает или работает не так, как ожидалось, и как это исправить.
8. В zip-архив OOoFBTools теперь будет всегда включаться папка scheme с документацией по схеме FictionBook2.1 - Наглядно видна вся структура и расположение стихов, эпиграфов и т.д. в картинках. Удобная навигация. Это - помощь при форматировании стилями текста книги перед экспортом, чтобы файл получится валидным.
9. Мелкие улучшения.

OOoFBTools-1.3.7
1. Изменение в Инструменте поиска OCR-ошибок "Поиск обрыва предложения на словах, знаках препинания, кавычках и скобках" - Теперь отлавливаем разные ситуации обрыва предложения. Для поиска используется шаблон регулярных выражений: \<[:alnum:]+$|\<[:alnum:]+[)}\],»”\"":;]$|\<[:alnum:]+[)}\]\.,»”\"":;]+[)}\],»”\"":;]$
2. Изменения в Справке в месте описания шаблона поиска для этого инструмента.

OOoFBTools-1.3.8
1. Переписал парсеры экспорта Текстовых Врезок, как "Таблица", "Текст", "Цитата" и "Структура". Теперь из Врезок экспортируются картинки разных привязок: "К Абзацу", "К символу" и "Как символ".
2. В Диалоге Настройки при нажатии кнопки "По умолчанию" для Врезок - экспорт по-умолчанию теперь - не как "Таблица", а как "Структура". Так логичнее.
3. Изменения в код парсера таблиц. В некоторых случаях при разных привязках Графики в ячейках после экспорта могло нарушиться соответствие номера картинки самой картинки (редкие случаи, еле отловил, но зачем нужны баги?). Изменил алгоритм - теперь все корректно.
4. Изменил парсер Ячеек Таблиц. Теперь из Ячеек Таблиц экспортируются картинки разных привязок: "К Абзацу", "К символу" и "Как символ".
5. Отлов в Таблицах и Врезках нумерованных списков и сохранение при их наличии в UTF-8, даже, если в основном тексте документа нет ни одного маркера (при включенной опции в Настройках).
6. При запуске экспорта изменил проверку на изменение в документе. Теперь, вместо сообщения "Сохраните документ" и жеского прекращения экспорта выдается это же сообщение, но с приглашением: "Вы все равно хотите экспортировать?" и выбором действия  "Да" - экспортируем (если картинки получатся "обгрызанные" - не обессудьте), или "Нет" - отмена экспорта. Это возможность выбора полезна в некоторых случаях: некоторые файлы с таблицами сразу же после открытия их в редакторе приобретают признак "изменен", хотя изменений в них - нет (Я пока не разобрался, почему это происходит внутри OOo). Теперь их можно экспортировать - картинки получатся "хорошими", не "обгрызанными".
7. Изменения в Справке в части Врезок, Таблиц, Вопросы и Ответы, а также удалил из Справки устаревшую информацию про установку скрипта для Linux для экспорта картинок - давно уже "работаем" без него.
8. Мелкие улучшения и исправления.

OOoFBTools-1.3.9
1. Для OCR-инструмента поиска "Обрыва предложения на словах, знаках препинания, кавычках и скобках" исправил ошибку нажатия кнопки "Обработать" - в некоторых случаях вместо найденного обрыва обрабатывался следующий
2. Для OCR-инструмента поиска "Слово с тире, дефисом или минусом" для запоминания найденного дефисного слова и игнорировании его при следующем поиске ввел оптимизацию: все дефисные слова запоминаются и потом проверяются в нижнем регистре. Это уменьшает число дефисных слов в файле, а, следовательно - и время на перебор их всех при очередном нажатии клавише "Найти".
3. Профиль Автора FB2-документа: Теперь запоминается (при нажатии кнопки ">>") и восстанавливается (либо при открытии формы конвертора, лиибо при нажатии кнопки "<<") www для создателя fb2-файла (Source URLs).

OOoFBTools-1.4.0
1. Исправил опечатку в названии жанра: с prose_rus_classsic на prose_rus_classic.
2. Расширил обработку и экспорт Картинок: Теперь "отлавливаются" и Shape-объекты (Картинки).
3. Подправил в Ручном инструменте OCR ошибок - "Недостающий пробел между слов" режим Вставки пробела слева или справа от найденного символа. Раньше в некоторых случаях пробел вставлялся в следующей паре "слипшихся" слов. Поменял алгоритм обработки.
4. Теперь этот инструмент "не отлавливает" дроби.
5. Инструмент поиска OCR ошибок "Слово с дефисом, тире или минусом" - теперь запоминает в Словарь сразу все комбинации слова - и с минусом, и с тире, и т.д.
6. Исправил баг - лишний пробел после кавычек, верхних или нижних индексов...

OOoFBTools-1.5.0
1. Расширен список языков Книги и изменен их вид на более удобный для пользователя.
2. Новый инструмент - Анализатор Структуры.
Если заголовки отформатированы стилем Level не так, как этого "требует" алгоритм конвертора (например: Level1 - текст - Level3 - текст - Level3 - текст (что вполне допустимо схемой, но пока недопустимо для конвертора), а надо для алгоритма конвертора Level1 - текст - Level2 - текст - Level3 - текст, то, вследствии особенности алгоритма конвертора, появятся лишние теги </section> - fb2-файл получится невалидным. А вышеприведенный пример структуры - типичное явление для html-файлов.
Анализатор Структуры помогает увидеть, какие заголовки неверно отформатированы стилями Level, и исправить это. Он не вносит никакие изменения в текст и никак не влияет на экспорт! Если вы не исправите сами стиль указанного Анализатором Заголовка на "нужный", то получите невалидный файл. Алгоритм конвертора пока остался ПРЕЖНИМ.
Когда конвертер сможет в будущем корректно обрабатывать ситуации Level1 - текст - Level3 - текст, то Анализатор Структуры будет удален, как ненужный.
3. Исправлен баг по работе со стилями локальных Заголовоков (проявляется только при переопределении стилей Level на Стандартные Заголовки разных языков). Внесены изменения в ядро OOoFBTools по работе с переопределенными пользователем стилями. Алгоритм конвертера не изменен. Переопределение стилей Level на Стандартные Заголовки теперь корректно работает (пока) для следующих языков:
Русский, Английский, Эспанский, Немецкий, Французский. Список языков будет постепенно расширяться, по мере "просмотра" названий Стандартных Заголовков в разноязычных OOo. Если хотите, чтобы для OOo ВАШЕЙ страны (языка), переопределение стилей Level на Стандартные Заголовки корректно обрабатывалось - пришлите мне НАЗВАНИЕ языка и НАЗВАНИЕ Заголовка 1...
4. Для разных инструментов сделал отображение прогресса загрузки диалога и выполнение задач. Так удобнее и нагляднее - только знаешь, что инструмент "запустился".
5. Исправил неверный экспорт стихов с Эпиграфами. Если в Стихе есть Эпиграф, то для того, чтобы конвертер мог "отличить", что абзацы со стилем Poem  после Эпиграфа - это НЕ стихи САМОГО Эпиграфа, надо после Эпиграфа поставить пустой абзац со стилем Epigraph Author. Иначе - конвертер "вложит" абзацы со стилем Poem, идущие после Epigraph "внутрь" Эпиграфа, "считая", что эти стихи - часть Эпиграфа.
Будьте внимательны!!!
6. В инструменте "Поиск OCR ошибок в тексте" для режима "Слово с тире, дефисом или минусом" сделал возможность поиска ВСЕХ дефисов, тире или минусов в пределах лдного слова. Например: Есть слово "Кое-ко-го". Раньше инструмент находил только "Кое-ко", а теперь - и "Кое-ко" и "ко-го" в пределах этого слова.
7. В инструменте "Поиск OCR ошибок в тексте" для режима "Слово с тире, дефисом или минусом" сделана возможность вставлять пробелы слева и справа от найденного минуса, тире или дефиса (Кнопка "Вставить пробелы").
8. Изменения и доролнения в Справке - в части работы со Стихами, Ручные инструменты...
9. Мелкие исправления и улучшения.

P.S. Пока не переделан экспорт нумерованных списков для OOo 3.1.0. Для версий более ранних - все работает. Для последней версии Опен Офис - номера нумерованных списков пока не экспортируются, а только текст списка.

OOoFBTools-1.5.1
1. В инструменте "Поиск OCR ошибок в тексте" для режима "Слово с тире, дефисом или минусом" исправил ситуацию, когда в тексте встречается слово с тире, минусом или дефисом и @ (например, vasja-pupkin@mail.ru). Инструмент стопорился на таких email, и дальше не шел. Теперь все работает.
2. Исправлен баг в Инструменте "Поиск OCR ошибок в тексте" - "Слово с разорванным абзацем переносом (дефис, тире или минус)" - Инструмент стопорился на дефисных словах. Исправлено.
3. Объединены инструменты поиска ошибок OCR "Обрыв предложений на словах..." и "Место с недостающим знаком препинания в конце абзаца". Добавлена кнопка вставки различных знаков препинания...

OOoFBTools-1.6.0
1. ИЗМЕНЕНИЕ АЛГОРИТМА по работе с <srection>:
Раньше fb2-файл получался валидным только при определенной разметке стилями Заголовков, например: Level1 ... Level2 ... Level3 ... Level1 ...
Такая разметка недопускалась - файл получался невалидным: Level1 ... Level5 ... Level3 ... Level1 ...
ТЕПЕРЬ алгоритм изменен, и разметка вида Level1 ... Level5 ... Level3 ... Level1 ... не приведет к невалиднеости fb2-файла. "Недостающие" секции между Level1 и Level5 (в этом примере), будут вставлены.
2. Исправил "поломку" - экспорт нумерованных списков (уже в 3-й раз(!) - Sun часто меняет члены объекта абзаца).
Должно работать на всех версиях OOo.
3. УДАЛЕН Анализатор Структуры (Levels-Заголовков), т.к. он теперь вообще не нужен.

OOoFBTools-1.7.0
1. Исправил серьезную ошибку, которую допустил при создании версии 1.6.0 - из-за нее некоторые инструменты не работали, а OOo просто вылетал.
2. НОВЫЙ инструмент вычитки (QWERT -> ЙЦУКЕ -> QWERT) - перекодировка выделенного фрагмента текста с русского на английский и наоборот. Полезен в том случае, когда набрал русский текст при английской раскладке (и наоборот).

OOoFBTools-1.8.0
1. Новый инструмент Вычитки - Автоматическая Склейка разорванных строк в одном парагфаре, разорванных символом абзаца - Режим "По "пустому" абзацу". Инструмент находится в Корректоре Текста в группе "Собрать разорванные символом ¶ строки абзаца в один абзац" (3-й). Очень полезная вещь при обработке многих текстовых файлов из сети или документы, полученные путем копирования некоторых pdf-журналов. Режим «По ”пустому” абзацу» - программа ищет блок текста (как правило разорванные строки одного абзаца) по идентификаторам – «пустой» абзац. Найденное склеивается в один абзац.
Подробнее и пример см. в разделе Справки: II.1.2. Собрать разорванные символом ¶ строки абзаца в один абзац

OOoFBTools-1.9.0
1. В некоторых случаях Сложной Генерации сносок падала. Исправил
2. Вычитка - Корректор Текста - Новая опция: "Вставка пробела между "слипшимися" символом и минусом, тире или дефисом"
3. Дополнения в Спрвке.

OOoFBTools-1.10
1. Исправил ошибку в работе Корректора Текста Опции "Собрать разорванные символом ¶ строки абзаца в один абзац" режима принадлежности строк к одному абзацу "По .!?…”»":; в конце абзаца". Если в конце каждой разорванной строки стоял пробел, то склейка разорванных строк абзаца в один происходила неверно. Исправлено.
2. Инструмент Вычитки - Поиск Ошибок OCR - Новая опция «Искать далее после обработки найденного»: Если она выключена, то после того, как инструмент нашел ошибку OCR, и вы ее обработали с помощью кнопок обработки, текстовый курсок остается на найденном, и чтобы найти новую ошибку OCR, надо нажать кнопку «Найти». И так – до конца книги. Если же опция «Искать далее после обработки найденного» включена, то после обработки найденной ошибки автоматически происходит переход на новую ошибку в тексте! Это очень удобно!

OOoFBTools-1.11
1. Исправлена ошибка В Генераторе Сносок - текст некоторых сносок урезался на 1 символ справа. Исправлено.
2. Внесены КРИТИЧЕСКИЕ исправления и дополнения в ряд инструментов Вычитки, работающих с выделениями в тексте (из-за частых изменений в коде  разработчиками OOo Writer).
3. Добавлена интеллектуализация в инструмент генерации сносок по "распознаванию" некоторых ошибок OCR.
4. Новый интерактивный инструмент для Вычитки: "Поиск и преобразование номеров сносок в верхнем индексе". Полезен для ручного поиска номеров сносок в верхнем индексе для преобразование их к виду по шаблону, для дальнейшей автоматической генерации сносок. Автоматическое преобразование номеров в верхнем индексе к виду по шаблону (существующий инструмент) НЕЛЬЗЯ использовать в ряде книг, где цифрами в верхнем индексе обозначаются не только сноски, но и другая информация (Библия, Коран, книги по математике и т.д.), т.к. по шаблону преобразуются не только номера сносок, но и другая информация. Поэтому, используйте в таких книгах "Поиск и преобразование номеров сносок в верхнем индексе", пропуская не сноски, и преобразовывая по шаблону именно сноски. Подробнее см. в Справке раздел "4. Интерактивное преобразование номеров примечаний в верхнем индексе по шаблону".
5. Новый инструмент Вычитки - "Нумерация выделенных абзацев". Можно указывать начальное значение нумерации. Если выделено несколько областей документа, то можно использовать опцию "Сквозная нумерация для нескольких выделенных областей текста", т.е. в 1-й области абзацы будут пронумерованы, например, 1. 2. 3. , во 2-й - 3. 4. 5. и т.д. (Вид нумерации можно выбрать). Если нет ни одной выделенной области документа, то выдается запрос на обработку всего Документа. Если в выделенной области текста есть нумерованные списки, то автонумерацию для этих абзацев отключается, и они нумеруются по-порядку... Если обрабатываемый абзац - нумерованный список, то автонумерация отключается. Если же этот абзац - простой абзац, то он пронумеровывается без автонумерации. Т.е. в любом случае для обрабатываемых абзацев автонумерация отключается!
Этот инструмент крайне полезен для автоматической генерации сносок, в которой не обрабатываются нумерованные списки текста примечаний. Если после OCR есть ТАКИЕ списки с автонумерацией, то их можно пронумеровать инструментом "Нумерация выделенных абзацев", и после - запускать инструмент автогенерации сносок! (Мне это сэкономило массу времени)
6. Дополнения в Справке.

OOoFBTools-1.12
1. Исправлена ошибка в генераторе сносок - вылет на сортировке сносок.
2. Имправлена КРИТИЧЕСКАЯ(!) ошибка в парсере Конвертера. Если заголовки Глав (стиль Level) состоят из нескольких абзацев, и один из ЭТИХ абзацеы - пустой абзац, то при экспорте абазцы ТАКОГО Заголовка ПОСЛЕ пустого абзаца ТЕРЯЛИСЬ. Файл получался невалидным.
Исправлен парсер.
3. Инструмент "Поиск OCR ошибок в тексте": При нажатии на кнопку Запомнить (дефисное слово), если включена опция "Искать далее после обработки найденного" после запоминания дефисного слова в Словарь поиск продолжается.
4. Инструмент "Поиск OCR ошибок в тексте": Сохранение и восстановление состояния опции "Искать далее после обработки найденного" при закрытии и открытии инструмента.
5. Инструмент "Поиск OCR ошибок в тексте", режим "Поиск слов, в которых абзац разорвал перенос (дефис, тире или минус)"/
Добавлен поиск разрыва слова на минусе, тире или дефисе с комбинацией пробелов. Т.е., если после знака переноса стоит один или пробелов, то такие слова тоже находятся. Например: «давным- ¶», «из-  ¶», «пересмотре-      ¶»
6. Инструмент "Поиск OCR ошибок в тексте", режим "Поиск обрыва предложения на словах, знаках препинания, кавычках и скобках".
Добавлен поиск разрыва предложения на минусе, тире или дефисе с комбинацией пробелов:
Пример текста:
	Здесь – разрыв после пробела и тире –¶
	А здесь – разрыв после 2-х пробелов, минуса и пробела  - ¶
Т.е. отлавливаются не только разрывы на запятых, скобках и словах, но и на минусе, тире и дефисах, слева от которых стоит 1 или более пробелов, а справа – ни один или множество пробелов (частая ошибка OCR).
7. Улучшена работа переопределения стилей для Французской, Немецкой локализаций.
8. Переделан алгоритм генерации секций <section>...</section>. В некоторых случаях форматирование Заголовков стилями Level в произвольном виду приводило к невалидному результату. Теперь Корректно конвертируются структуры вида:
Level1 ... Level5 ...;
Level3 ... Level2 ... Level;
Level3 ... Level3 ... Leve5 ... Level 1, и т.д.
Это особенно актуально для тех, кто конвертирует html-тексты, где часто 1-й Заголовок - стиль Заголовок 6, 2-й - Заголовок 3 и т.д., а пользователю лень отстилизовать Заголовки по уровню вложенности, как в книге, или же просто ошибся в номерации уровней. Или же - это такой замысел создателя fb2-файла.
Теперь все корректно работает - файл получится валидным.
"Стандартного" вида структуры Level1 ... Level2 ... Level3 ... Level1 и т.д. тоже корректно экспортируются, как и раньше.
Теперь конвертер действительно (по крайней мере в секциях) выдает именно то, что вы ему задали.
9. Исправил баг в инструменте "Нумерация выделенных абзацев" - если выделенные абзацы - в самом конце документа, то инструмент зацикливался на последнем абзаце. Исправлено.
10. Расширил в Справке раздел Вопросы - Ответы: Об экспорте обложек; Работа со стилями. Очень важная информация!!! Масса вопросов отпадает!!!
11. Улучшена работа Корректора Текста. Для опции "Собрать разорванные символом ¶ строки абзаца в один абзац". Теперь происходит склейка и тек строк в абзацы, которые разорваны разрвом строк, а не абзацев (BR из html-файлов).
12. Для Windows для Валидатора fb2-файлов и проверки на валидность сгенерированного конвертером fb2-файла внесены изменения по работе с MSLibXML. По идеи, теперь валидация должна работать и на Windows 7.
13. Основная форма Конвертера: 1. Возможность загружать и сохранять профиль Автора fb2-файла ПО-УМОЛЧАНИЮ (как было раньше) - кнопки "<<" и ">>" соответственно; 2. Возможность загружать и сохранять профиль Автора fb2-файла В ПРОИЗВОЛЬНЫЙ txt-файл - кнопки "A <<" и ">> A" соответственно.
Т.е., при старте диалога конвертера автоматически загружается профиль Автора fb2-файла ПО-УМОЛЧАНИЮ. Его можно изменить и сохранить. Если же надо загрузить (и (или) сохранить) профиль другого Автора fb2-файла, то используйте кнопки "A <<" и ">> A".
14. Дополнения в Справке.

OOoFBTools-1.13
1. Инструмент "Поиск OCR ошибок в тексте":
	а). Улучшение работы всех режимов в Таблицах.
	б). Для режима "Слово с дефисом, тире или минусом" сделана новая опция «Искать между цифрами».
	Она нужна для возможности включить/отключить поиск минуса, тире и дефиса между цифрами. Очень часто в книгах встречаются такие конструкции: 12-34, 1972-2010 и т.д. (В христианской литературе – это ссылка на стихи Библии, например, Мф. 5:1-8. В исторических книгах – это указание на отрезок времени. И т.д.). В таких книгах, как правило, минус, тире или дефис между цифрами – это не ошибка OCR, а норма. При вычитке инструмент часто находит такие цифры с дефисами, что утомляет. Чтобы пропустить эти «правильные» цифры и не тратить на них время нужно отключить опцию «Искать между цифрами». Очень удобно.
	в). Для режима "Место с недостающим пробелом между словами (вероятно)" сделана возможность поиска и обработки И цифр. Т.е. теперь "отлавливаются" и такие ситуации: в«2-й зоне», во»2-й, в2 раза, 2раза и т.д.
	г). Для режима "Место с недостающим пробелом между словами (вероятно)" сделана новая опция «Искать между цифрами».
	Она нужна для возможности включить/отключить поиск недостающего пробела между цифрами. Очень часто в книгах встречаются такие конструкции: 12,34, 1972:2010 и т.д. (В христианской литературе – это ссылка на стихи Библии, например, Ин. 3:16. В математических книгах и книгах по программированию – это указание на числовые диапазоны, просто дробные числа. И т.д.). В таких книгах, как правило, отсутствие пробела между цифрами – это не ошибка OCR, а норма. При вычитке инструмент часто находит такие цифры "без пробела", что утомляет. Чтобы пропустить эти «правильные» цифры и не тратить на них время нужно отключить опцию «Искать между цифрами». Очень удобно.
2. Конвертер ExportToFB21:
	а). Улучшен генератор секций. Весь текст ДО Названия книги относится к служебной области, и там обычно размещают данные описания (Description). И, если в этой области есть просто текст, не относящийся к (Description) (разная информация о книге, личные заметки и т.д.), то этот текст не будет экспортирован. НО! Если в это области ДО Названия Заголовка (стиль Book Title) будет хоть один абзац размечен стилями Заголовков (Level N, Заголовок N ...), то генератор секций генерировал начальную секцию неверно, что приводило к невалидности fb2-файла. (Попался мне один такой файл из сети :-) ).
Теперь все такие ситуации отлавливаются и генерация секций происходит корректно.
	б). Исправил очень старый баг (странно, что никто не сообщил о нем): В тексте гиперссылки (в fb2-коде - тег <a l:href=), не обрабатывались символы &,< и >. Файл получался невалидный.
	в). Тоже самое, только в названии закладок (для перехода по ссылкам внутри документа). Символы &,< и > просто заменяются на "_".
	г). Исправил старый баг: В Таблицах, если строка разорвана <BR> (html-файлы), и при этом является гиперссылкой - fb2-файл получался невалидным. Теперь все работает.
3. Расширил в Справке раздел Вопросы-Ответы:
	а). Новой часть "Разметка структур стилями". Здесь будут собираться ответы на вопросы по разным тонкостям и приемам форматирования абзацев стилями для эксорта нужных структур.
	б). Часть Картинки существенно увеличилась!!!
	в). Новая чать - Вылет ошибки при конвертировании. Здесь будут собираться ответы на вопросы по ошибкам экспорта, не связанным с ошибками в коде программы, а из-за неверных действий пользователя (редко, но бывает). Уже есть один важных ответ.
	
OOoFBTools-1.14
1. Конвертер ExportToFB21:
	а). Исправлена ошибка экспорта файлов с картинками при 'root' логине на Linux, FreeBSD и т.д. (спасибо dimgord).
	б). Старая схема Жанров FictionBookGenres.xsd заменена на новую.
	в). В Выпадающий список Жанров для Схемы 2.2 добавлены жанры: Для Раздела "Справочники" - "GEO Справочники" (geo_guides); для раздела "Документальное" - "Периодика" (periodic).
	г). Запоминание выбранной Схемы Жанров и Кодировки при закрытии и восстановление при запуске основной формы конвертера.
	д). Запоминание выбранной Схемы Жанров и Списка Жанров для диалога Избранных Жанров.
	е). Запоминание выбранной Схемы Жанров и Списка Жанров для диалога вставки Жанров в Служебную область.
	ж). Улучшена инициализация запуска основной формы конвертера - визуальное отображение прогресса.
2. Валидатор:
	а). Улучшение работы.
3. Инструмент "Поиск OCR ошибок в тексте":
	б). Для режима "Место с недостающим пробелом между словами (вероятно)" усовершенствовал алгоритм автоматического определения местоположения для вставки недостающего пробела.
	в). Для режима "Место с недостающим пробелом между словами (вероятно)" теперь реализована возможность поиска нескольких "слипшихся" подряд слов (букв) после OCR. Например: ц.н.с. Раньше алгоритм находил только "ц.н" и игнорировал "н.с" в этом же "слове". Теперь, после обработки "ц.н" будет найдено "н.с".
	г). Название режима "Обрыв предложения на словах, знаках препинания, кавычках и скобках" переименовал в "Обрыв абзаца на словах, знаках препинания, кавычках и скобках".
	д). Для режима "Обрыв абзаца на словах, знаках препинания, кавычках и скобках" введена кнопка "Склеить". Если кнопка "Обработать" удаляет разрыв и вставляет пробел, то новая кнопка "Склеить" просто удаляет разрыв. Часто после OCR (Особенно в FR10) слово оказывается разорванным. Например: Он при¶шел домой. Если нажать "Обработать", то получится "Он при шел домой". Если "Склеить", то "Он пришел домой".
4. Генератор сносок:
	а). Расстановка закладок для глав и списка(ов) примечаний - Исправлена ошибка проверки местоположения уже существующих закладок и их числа. В некоторых случаях программа "вылетала".
	б). Увеличено число шаблонов для № примечания в списке примечаний (Сложная генерация сносок).
	в). Исправил ошибку для режима Сложной генерации сносок, нумерация - сквозная, список примечаний - а конце книги: На шаблонах, отличных от "x." тест показывал число обработанных номеров примечаний во всех главах книги больше, чем их есть на самом деле (хотя на генерацию сносок это никак не отражалось). Теперь данные теста корректны.
	г). Исправлена ошибка - Тест вылетал, если в Документе встречались Текстовые Врезки и/или Таблицы. Исправлено.
	д). Улучшил генерацию текста Теста. Убрал вывод лишней информации, которая только отвлекает, и ввел вывод сообщения, что ВСЕ OK, если найдено полное соответствие всем номерам примечаний в каждой главе соответствующим им текстам примечаний из Списков....
	е). Для режима Сложной генерации сносок ввел проверку на наличие Текстовых Врезок и Таблиц в Документе. Если в Документе есть хоть одна Врезка или Таблица, выдается сообщение-подсказка, что нужно сделать. Дело в том, что OOo Writer не может вставлять Таблицы в сноски. А Генератор сносок и Тест не могут корректно работать, если в Списках примечаний есть таблица и/или Текстовая Врезка. Поэтому, в случае такой ситуации выдается сообщение-подсказка в текстовом поле формы Генератора сносок. Дальнейшая работа - на ваш страх и риск. Лучшее - просмотреть Документ, в частности все Списки примечаний (они помечены закладками _ooo_ocr_tc_foot_note_list_zone_dikbsd_ ... _ooo_ocr_tc_foot_note_list_zone_dikbsd_1 ... _ooo_ocr_tc_foot_note_list_zone_dikbsd_N - легко найти в Навигаторе OOo - по F5), и откорректировать Списки. Для этого надо в Списках примечаний текст Врезки вынести из нее в текст Списка примечаний, Врезку удалить. А Таблицы можно отскриншотить в виде картинки, саму таблицу удалить, а после генерации сносок вставить эту картинку в нужное место нужной сноски.
	Такая защита сделана в силу ограничения самого OOo Writer, а также, во избежания неверной работы генератора сносок.
	ж). Расширил раздел Справки, посвященный Генератору сносок и Тесту. Посмотрите - много вопросов отпадет!
5. Интерактивное преобразование номеров примечаний в верхнем индексе:
	а). Увеличено число шаблонов для № примечания в списке примечаний.
	б). Исправлена ошибка - при преобразовании найденного номера(символа) в верхнем индексе к выбранному шаблону для номеров примечаний в Списке примечаний, не вставлялась левая часть шаблона (до номера или символа).
5. Нумерация выделенных абзацев:
	а). Увеличено число шаблонов для нумерации.
	
OOoFBTools-1.15
1. Конвертер ExportToFB21:
	а). Переделан экспорт Картинок, Формул и Диаграмм. Алгоритм стал более универсальным. Раньше программа "вылетала" с ошибкой, если встречался нестандартный тип картинки.
	б). Исправлена ошибка вылета конвертора при экспорте картинок, если в документе была не сама картинка, а ссылка на сайт (http:/// или ftp:/// или https:///). Исправлено. Теперь экспортируется тэг этой картинки в нужном месте fb2-файла, а сама картинка - нет, т.к. ее "не достать".
	в). Увеличено число экспортируемых картинок - векторная графика.
	г). Дополнил FAQ по Картинкам в Справке.
	д). Сделан экспорт пустых строк для Аннотации Книги.
	е). Сделан экспорт нумерованных и маркерованных списков из текста сносок (Примечаний).
	ж). Значительные улучшения экспорта сносок!
	з). Дополнения в файле-примере ExportToFB21_Test-2.odt (Часть III.  Нумерция и Маркеры в тексте Сносок)
	и). Дополнения в Справке в Разделе Вопросы-Ответы/Картинки - 8. Не экспортируются Картинки и Графика из текста Сносок (Примечаний)
2. Ручная обработка абзацев - Новый инструмент. Обрабатывает либо один или несколько выделенных фрагментов текста, либо весь документ. Может делать:
	1). Инструмент "Обрыв абзаца (¶)" :
		а). Склейка в 1 абзац ( Замена обрыв абзаца ¶ на 1 пробел )
		б). Склейка в 1 абзац ( Удаление обрыв абзаца ¶ )
		в). Заменить обрыв абзаца ¶ на разрыв строки \n
	2). Разрыв строки (\n)
		а). Склейка в 1 абзац ( Замена обрыва строки \n на 1 пробел )
		б). Склейка в 1 абзац ( Удаление обрыва строки \n )
		в). Заменить разрыв строки \n на обрыв абзаца ¶
	Инструменты очень удобны в тех случаях, когда надо склеить разорванные абзацы или строки в один абзац в отдельных частях документа, а автоматическая склейка в Корректоре Текста может склеить и те абзацы, которые не нуждаются в этом. Подробности см. в Справке.
	a). Новый раздел в Справке "III.2. Обработка выделенных абзацев (обрыв абзаца или строки)" - описание Нового инструмента.

OOoFBTools-1.16
1. Общее: Перегруппировал пункты меню и снопки на панелях инструментов OOoFBTools. Теперь инструменты логически находятся в "своих" группах - легче ориентироваться.
2. Инструмент "Поиск OCR ошибок в тексте":
	а). Для режима "Слово с дефисом, тире или минусом" ПОЧИНИЛ поиск таких случаев, как, например "кого-ни-будь". Инструмент ищет "кого-ни", а потом, после продолжения поиска - и "ни-будь" в этом же слове.
3. Конвертер ExportToFB21:
	а). Экспорт картинок и графики из Аннотации на Книгу (Служеюная область). Привязка Графики не имеет значения - экспортируется любая привязка.
	б). Изменения в алгоритме опознавания Обложек. Теперь картинки, расположенные в Служебной зоне в Аннотации на Книгу не воспринимаются, как Обложки.
	в). Исправил баг - если в документе есть только один Заголовок (Уровнь), то последний абзац не экспортировался. Исправил.
	г). НОВОЕ: Экспорт Графики (Картинки, Формулы и Диаграммы) из текста Сносок. В зависимости от привязки, Графика экспортируется либо как отдельная Картинка, либо как Буквицы - Картика-символ (Как это реализовано для экспорта Графики из Текста Документа).
	д). Улучшена обработка и чистка "мусора" в коде - удаление при включенной опции в Настройках пустышек, типа <strong></strong> и т.д.
	е). Дополнил файлы ExportToFB21_Test-1.odt и ExportToFB21_Test-2.odt
	ж). Переименовал файлы ExportToFB21_Test-1.odt и ExportToFB21_Test-2.odt в ExportToFB21_example-1.odt и ExportToFB21_example-2.odt соответственно, т.к. народ путается, думая, что это - тест, а это - просто файлы для иллюстрации возможностей Конвертера.
	з). Сделал возможность отключать в Настройках Конвертера Экспорт Текстовых Полей (по-умолчанию включен). Полезно, когда в Тексте есть "не нужные" поля - можно просто отключить их экспорт.
	и). Испраил старый баг: При изменении Настроек (нажатие Ok) и сразу - экспорт - данные для Бумажной Книги "удваивались" - например, в конец названия книги дописывалось это же название. И т.д. Исправил.
	к). Мелкие улучшения

OOoFBTools-1.16.1
1. Конвертер ExportToFB21:
	а). Улучшение работы служебных стилей (исправлен баг).
	
OOoFBTools-1.17
1. Общее:
	а). Оптимизация кода
	б). Изменения в Справке.
2. Конвертер ExportToFB21:
	а). Упрощение интерфейса Настроек (для упрощения кода конвертера):
		- Удалена опция "Форматирование (bold, гиперссылка...) текста сносок". Теперь ВСЕГДА экспортируется форматирование текста сносок.
		- Удалена опция "Экспорт сложных структур сноски (стихи, уровни...)". Теперь текст сносок ВСЕГДА экспортируется, как сложные структуры. При этом, если в тексте сносок абзацы не отформатированы, как Стихи, Заголовки и т.д., то они эксортируются как простой текст.
	б). НОВОЕ: Экспорт перехода из текста одной сноски на текст другой (часто полезно для научных и познавательных книг, где в тексте одной сноски ссылаются на текст другой сноски).
	Т.е., теперь экспорт переходов внутри документа работает полностью:
	- переход из любого места документа в любое место документа;
	- переход из любого места документа на текст любой сноски;
	- переход с текста сноски на любое место документа; и
	- переход из текста одной сноски на текст другой сноски.
	Для Таблиц и Врезок данный экспорт не работает...
	Принцип работы - как и прежде. Для задания внутренних ссылок (переходов) необходимо следующее:
	(1). На абзац, КУДА нужно перейти, ставим закладку.
	(2). В абзаце, ОТКУДА нужно перейти, выделяем слово или словосочетание-переход, и форматируем его, как гиперссылку (меню Вставка->Гиперссылка). В диалоге для Документа выбираем Цель — Закладки, а там — нужную закладку для абзаца КУДА. Жмем Применить, закрываем диалог Цели, жмем Применить, закрываем диалог Гиперссылки. Все!
	См. пример в файле ExportToFB21_example-1.odt в разделе "Часть 5. Ссылки и переходы внутри документа"
	в). НОВЫЙ раздел в Справке: 4.9. Работа с внутренними ссылками (гиперссылки). Описаны возможности экспорта внутренних ссылок и подробный процесс их формирования.
	г). НОВОЕ: Сложная генерация ID Книги (опция в Настройках по-умолчанию отключена). Генерируется ID Книги, исходя из данных Авторов Книги и всех Авторов fb2-файла.
	Принцип генерации: (а) Для русской локализации используется транслитерация и "строгие" символы (только цифры, латинские буквы и символ "-"); для всех остальных локализаций - только "строгие символы". (б) При формировании ID приоритет отдается Нику Автора Книги (fb2-файла), ФИО - игнорируется. Если Ника нет, то тогда используются Фамилия и Имя (Отчество игнорируется для сокращения размера строки ID). (в) В генерации участвуют данные всех Авторов Книги  всех Авторов fb2-файла. (г) Ввод данных в соответствующие поля влияет на генерацию ID.
3. Инструмент генерации сносок:
	а). Упорядочил локализацию сообщений...
	б). Улучшен алгоритм Теста для Генератора Сносок. Теперь учитывается комбинаторика.
	в). НОВОЕ: Новые шаблоны генерации Сносок: Номера Примечаний в Тексте и (или) в Списке примечаний - в виде цифр в верхнем индексе. Т.е., если в Книге есть именно такой тип номеров Примечаний, то теперь их преобразовывать к одному из шаблонных видов не надо!
	г). НОВОЕ: Генератор Гиперссылок (внутренние ссылки-переходы). Полезен в том случае, когда по каким-либо причинам предпочтительнее генерировать из примечаний не сноски, а гиперссылки на примечания. Генератор Сносок и Генератор Гиперссылок реализованы в общем диалоге, где можно задать режим генерации - либо Генерация Сносок, либо - Генерация Гиперссылок. Работа с Закладками зон номеров примечаний и списков самих примечаний такая же, как и для Генератора Сносок. Тест работает одинаково для обоих Генераторов.
	Подробнее см. Справку.
	д). Переделан и расширен раздел Справки: III.3. Инструменты работы с примечаниями, сносками и гиперссылками
4. Загрузка стилей шаблона fb21_styles.ott в документ:
	а). В OOo версии 3.2 изменилось описание местонахождения файлов шаблонов, в следствии чего макрос "Загрузка шаблона стилей в документ" (иконка в виде захватывающей руки) перестал работать и выдает сообщение, что файл fb21_styles.ott не был загружен через диспетчер шаблонов, хотя он уже загружен. Изменил код, теперь все работает - стили загружаются в документ.
	
OOoFBTools-1.18
1. Общее:
	а). Улучшение кода.
2. Конвертер ExportToFB21:
	а). Исправлен баг - в названии ID гиперссылки генерировался пробел - особенность работы функций OOo. Файл получался невалидным. Исправлено.
	б). Убрал жуткие тормоза при сохранении сносок. На сохранение 1000 сносок тратилось 15-19 минут, теперь - 3-6 секунд.
	в). УДАЛЕН выбор экспорта символьных стилей (либо только один приоритетный, либо - все стили символа). Теперь все слова экспортируются со всеми своими символьными стилями (например, если слово выделено полужирным И курсивом И зачеркнуто, то ВСЕ эти стили и будут экспортированы).
	г). НОВОЕ: В Настройках для Экспорта Графики сделана возможность выбора экспорта jpg, jpeg и png картинок, как jpg, jpeg или png (как это было реализовано для других графических форматов). Полезно иногда экспортировать png картинки, как jpg для уменьшения размера файла!
	д). Исправлены мелкие баги в экспорте графики...
3. Инструмент генерации сносок и гиперссылок:
	а). НОВОЕ: Автоматическая генерация гиперссылки из разных мест Текста (Главы) на одно и тоже Примечание. Часто бывает в научных книгах, где на одно и тоже примечание ссылаются в разных абзацах главы.
	
OOoFBTools-1.19
1. Общее
	а). Дополнительная защита от падений различных инструментов
2. Конвертер ExportToFB21:
	а). Теперь экспорт графики работает и для портабельных версий OpenOffice.org Writer на системе Windows.
	б). Сделан экспорт гиперссылок на пустой абзац текста.
3. Генератор сносок и гиперссылок:
	а). Исправил ошибки теста и генерации сносок для шаблона "цифры в верхнем индексе".
	б). Исправил ошибку генерации гиперссылок для шаблона "цифры в верхнем индексе".
4. Корректор Текста:
	а). Добавил в обработку "Вставка пробела между "слипшимися" символом и мирусом, тире или дефисом" еще и круглые, фигурные и квадратные скобки.
	
OOoFBTools-1.20
1. Общее
	а). Оптимизация кода.
	б). Изменения и дополнения в Справке.
2. Конвертер
	а). Новое: Сделан вынос начальных и завершающих пробелов слов, если они есть, за тэги форматирования. Т.е, например, если в фразе "Linux и Windows" выделение курсивом сделано на "Linux " (т.е. захвачен пробел), то пробел не попадет в тэги <emphasis>. Т.е., вместо <emphasis>Linux </emphasis>и Windows мы получаем <emphasis>Linux</emphasis> и Windows.
	Это полезно для многих читалок, которые пробелы в тегах не "видят" и наша фраза "слепилась" бы в "Linuxи Windows".
	б). Новое: Сделан экспорт Автора Цитаты, когда нет самой Цитаты. Например, в книге после Введения находится имя его Автора. Введение мы не отмечаем, как Цитату. А Автора Введения - отметим стилем Cite Author. Раньше, для того, чтобы конвертер корректно экспортировал такую разметку текста, требовалось перед Автором Цитаты (стиль Cite Author) вставить пустой абзац со стилем Цитаты (Cite). Фрагмент fb2-файла получался таким: <cite><empty-line/><text-author>Автор</text-author></cite>
	Теперь перед Автором Цитаты, идущем после обыкновенного текста вставлять пустой абзац со стилем Cite не обязательно. Если абзац Автора Цитаты идет сразу же за простым текстом, то фрагмент fb2-файла получится таким: <cite><text-author>Автор</text-author></cite>.
	в). Обновил в Справке Раздел Вопросы-Ответы в части "Разметка структур стилями" относительно экспорта Автора Цитаты.
3. Корректор Текста
	а). НОВАЯ переключаемая опция: Удаление векторных линий (ShapeLine). Полезна при обработке текста после OCR, когда после экспорта из FineReader границы таблиц, линия над текстом сноскок и т.д. в тексте экспортируются, как векторные линии. При выборе этой опции Корректор автоматически удалит все эти линии.
	б). Улучшена обработка разрыва переноса: теперь обрабатывается не только разрыв абзаца, но и разрыв строки.
	в). Изменены названия элементов управления для Группы "Разорванные дефисы и переносы". Названия стали более понятны (по крайней мере, на русском :-) )
	г). Склейка разорванных абзацев и строк по идентификатору нового абзаца выделены из Корректора Текста в отдельный инструмент. Эта обработка перенесена в новый инструмент автоматической обработки "Склейка разорванных строк абзаца", т.к. в Корректоре Текста этот вид обработки используется крайне редко и логически "лишний".
4. Новый инструмент: "Склейка разорванных строк абзаца"
	Инструмент полезен для обработки html-ых файлов, а также текстов книг, на подобии книг из библиотеки Мошкова.
	а). Расширен алгоритм склейки: можно выбирать не только вид идентификатора нового абзаца, до которого все строки считаются принадлежащему к одному абзацу и склеиваются в один абзац, но и вид обработки разрывов абзацев и строк на переносах и дефисах. Подробнее см. в Справке Раздел "Склейка разорванных строк абзаца" Части "II. АВТОМАТИЧЕСКАЯ КОРРЕКТИРОВКА ТЕКСТА".
5. Новый инструмент: Вставка символа маркера • в начало заданных абзацев.
	Позволяет либо удалить маркеры у абзацев, и заменить их символом •, либо вставить символ • в неачало заданных абзацев. Это дает возможность экспорта текста не в UTF-8 кодировке, а в Windows-1251, что уменьшает размер полученного fb2-файла. С другой стороны, после OCR многие маркеры экспорптируются не корректно, и не видны в читалках. Данный инструмент решает эту проблему. Инструмент работает либо для всего текста, либо для выделенных абзацев. 2 режима работы: 1. Вставляет • для всех заданных абзацев; 2. Заменяет маркер на • только у тех абзацев, котрые отформатированы маркерами. Подробнее см. в Справке Раздел "III.4. Вставка символа маркера (•) в начало заданных абзацев" Части "III. ИНТЕРАКТИВНЫЕ ИНСТРУМЕНТЫ ОБРАБОТКИ ТЕКСТА".
	
OOoFBTools-1.21
1. Конвертер
	а). Исправлен баг экспорта: Если после Подзаголовка (стиль абзаца Subtitle) сразу же идет Подзаголовок Цитаты (CiteSubTitle) или Подзаголовок Стиха (PoemSubTitle), то конвертер неверно расставлял секции (section). Теперь экспорт проходит корректно.
2. Справка
	а). Исправлены многие неточности и ошибки в Справке (спасибо stas.grumbler за вычитку и ценные замечания).
	б). В Разделе "Вопросы – Ответы" в Части "Установка пакета OOoFBTools" создан новый подраздел "3. При установки расширения пакета OOoFBTools постоянно появляются сообщения об ошибке и пакет не устанавливается".
3. Новый инструмент: Замена простых пробелов на неразрывные.
	Название инструмента характеризует его назначение. Полезен, когда в документе заданы структуры текста простыми пробелами. В fb2-файле простые пробелы после конвертации сохраняются, но читалки и fb2-редакторы "воспринимают" множественные простые пробелы, как один. Тем самым структура текста нарушается. Данный инструмент просто заменяет все простые пробелы на неразрывные (сохраняя их число) либо в выделенных фрагментах текста, либо во всем документе.
	Подробнее см. соответствующий раздел Справки.
	
OOoFBTools-1.22
1. Конвертер
	а). Исправил баг: Если выход из Диалога Настройки делается нажатием кнопки Ok, то основное окно оставалось недоступным, его никак нельзя было закрыть, так что приходилось принудительно удалять Writer. Исправлено.
2. Генератор сносок и переходов:
	а). При запуске Теста генерации сносок или переходов диалог теперь становится недоступным до окончания теста. Это не даст возможности случайно запустить еще один Тест или Генгерацию...
3. Инструмент Отменить форматирование абзаца (Clear Paragraph Style)
	а). Стиль теперь сбрасывается не в "Базовый", а в "Основной текст". Спасибо за идею azhur.
Причина - http://wiki.services.openoffice.org/wiki/RU/kb/philosophy/paragraph_styles_basic_and_title

OOoFBTools-1.23
1. Общее
	а). Файл ChangeLog.txt переименован в ChangeLog_Rus.txt
	б). Добавлен файл ChangeLog_Eng.txt, где начат перевод истории развития программы на английский язык (Павел Крупин (PaulTheTortoise) : email: easter1980ster@gmail.com)
2. Генератор сносок и переходов:
	а). В режиме Теста теперь диалог Генератора сносок закрывается.
	б). Улучшение алгоритма поиска и генерации сносок.
3. Корректор Текста
	а). Улучшение работы опции "Упорядочить многоточия" Корректора ( Егор Чемисов (Kravejs) )
4. Конвертер:
	а). В диалоге Настройки опция "Запустить созданный fb2-файл (Просмотр)" по умолчанию теперь отключена. Актуально для первой установки пакета OOoFBTools.
	б). НОВОЕ: Возможность экспорта сносок и концевых сносок либо в один блок, либо - в разные блоки. Задается в диалоге Настройки (Issues 55)
	в). Внесены изменения в Справку.
	
OOoFBTools-1.24
1. Общее
	а). Замена файла ChangeLog_Eng.txt
	б). Исправил ошибку с локализацией названий инструментов. Теперь на русской локали инструменты отображаются по-русски, на остальных - по-английски.
2. Инструмент Замены простых пробелов на неразрывные
	а). Улучшен алгоритм работы. Теперь замена происходит корректно в границах выделенных блоков текста или всего документа.
3. Конвертер
	а). Инструмент вставки Языка книги - исправлен плавающий баг, когда стиль языка оригинала книги распространялся на следующий абзац, или же стиль не устанавливался.
4. Корректор Текста
	а). Полностью переработаны почти все опции Корректора для обработки не только художественной, но и научно-технической, религиозной и т.д. литературы.
	б). Созданы новые опции по работе с пробелами, дефисами и тире. Их комбинации позволяют обрабатывать книги самых различных типов.
	- Пояснения к опции "Заменить двойной минус (--) или двойной дефис (--) на тире (Smart Режим Замены)":
		Назначение этой опции понятно из ее названия. Пояснение требует только Smart режим. Обычно двойной минус встречается в книгах, которые были набраны еще в эпоху, когда тире имитировалось двойным минусом. Алгоритм обработки текста по этой опции создан таким образом, что «интеллектуально» подходит к двойным минусам в разных видах книг. Например, почти во всех книгах, кроме книг по программированию двойной минус следует заменять на тире и в прямой речи (в начале абзаца), и в середине предложений. Но в книгах по программированию двойным минусом обозначается либо декремент (например, --i), либо опция командной строки (например, --file). Поэтому рассматриваемая опция Корректора и создана, как Smart – т.е. Корректор отличает с определенной степенью погрешности, где следует заменять двойной минус на тире, а где – нет. Поэтому эту опцию можно использовать и для корректуры книг по программированию – декременты и опции сохранят «свои» минусы, а в тексте – заменятся на тире.
	в). Сделана перегруппировка разных опций по функциональности. Так логичнее.
	г). Сделаны профили готовых настроек для следующих типов книг:
	- Документы
	- Художественная литература
	- Документалистика, Публицистика
	- Научная литература
	- Техническая
	- По программированию
	- Религиозная литература
	Включение или отключение тех или иных опций для разного вида литературы (профили) обусловлено моим личным опытом. Буду раз любым замечаниям и пожеланиям...
5. Склейка разорванных строк абзаца
	а). Улучшена и расширена пост-обработка.
6. НОВЫЙ инструмент: Расстановка знака ударения над гласными русскими буквами. Принцип работы - если справа от гласной буквы стоит апостроф ('), то ставится ударение.
7. НОВОЕ. На YouTube начал выкладывать цикл видеоуроков по использованию OOoFBTools. Найти можно по поиску видеофалов пользователя DikBSD.

OOoFBTools-1.25
1. Корректор Текста
	а). Исправлена ошибка для опции: "Вместо минуса - дефис в "кое-что", "куда-то" и т.д.", когда обрабатывались и слова, начало которых начиналось с то|либо|нибудь|что|таки|ка|де|никак|никакой.
	б). Для опции "Дефисы и переносы, разорванные символом абзаца(¶) и строки:" введена интеллектуализация. Теперь склейка происходит только в случае, когда символ до знака переноса и символ после разрыва абзаца (пробелы игнорируются) являются буквами, причем одной языковой группы. Отслеживаются 5 групп: Cirillic, Latin, Greek, Hebrew и Arabic. Все группы включают основные и расширенные символы, но только буквы. Цифры игнорируются. Тайскую не стал вводить - вряд ли кто ей пользуется. Если нужна - пишите письмо на мой emeil.
	в). Улучшена работа опции "Заменить множество пробелов между словами на заданное число пробелов или табуляций".
	г). Улучшена работа опции "Заменить дефис или минус, используемый между слов вместо тире на тире" в плане обработок скобок.
	д). НОВАЯ опция "Заменить минус на дефис в уточняющих словах (черно-белый, дом-небоскреб, 1900-е и т.д.)"
	е). НОВАЯ опция "Заменить минус на дефис между цифрами".
	ж). НОВАЯ опция "Обработать пустые абзацы ¶". Имеет 2 режима: 1. Удалить все пустые абзацы. 2. Заменить множественные пустые абзацы одним ¶.
2. Расстановка знака ударения над гласными русскими буквами
	а). Добавил обработку букв Ё и ё
3. Инструмент "Интерактивное преобразование № сносок в верхнем индексе"
	а). Доработан поиск символов в верхнем индексе. Теперь инструмент ищет цифры или символы и в верхнем индексе, и просто смещенные вверх, относительно строки.
	б). Ввел поиск символов для 3-х режимов:
	- Только в верхнем индексе
	- Только в нижнем индексе
	- И в верхнем и в нижнем индексе
	Это бывает полезно при поиске в книге символов или цифр в разных индексах.
4. Генератор сносок и гиперссылок
	а). Внесены изменения в алгоритм. Теперь Генератор ищет не только номера сносок в верхнем индексе (как было раньше), но и цифры, просто смещенные вверх, относительно строки.
5. НОВЫЙ инструмент: "Обработка множественных пробелов и табуляций".
	Позволяет заменять множественные простые пробелы, неразрывные пробелы или табуляции на такое же число простых, неразрывных пробелов или табуляций. Работает в 2-х режимах. 1. В выделенных фрагментах текста. 2. Во всем документе. Для 2-го режима можно выбрать где производить посик и замену: а). Только в начале абзаца. или б). В любом месте текста.
	Инструмент полезен для создания в fb2-формате книг, содержащих структуры текста, например по программированию (код программ) или религиозные книги, где отступы абзацев в структурах можно задать либо пробелами, дибо табуляциями, а потом их заменить инструментом на неразрывные пробелы. В fb2-файле такие абзацы "отобразят" структуру абзацев!
	ВАЖНОЕ условие: для работы в режиме выделенных фрагментов текста, правая граница одного или нескольких выделений ОБЯЗАТЕЛЬНО должна захватывать хотя бы 1 символ текста, либо хотябы прикасаться к символу текста. Иначе инструмент не сработает!
6.	Удален Инструмент замены простых пробелов на неразрывные, т.к. он не мог работать со множественными пробелами, а заменял даже единичные. и его задача реализована в НОВОМ инструменте "Обработка множественных пробелов и табуляций".
7. Справка
	а). НОВЫЙ раздел: "Расстановка ударений над русскими гласными буквами".
	б). НОВЫЙ раздел: "Обработка множественных пробелов и табуляций". Очень подробно с иллюстрациями показана работа инструмента и в каких случаях он просто незаменим.
	в). Внесены изменения в раздел: "Интерактивное преобразование номеров примечаний в верхнем индексе по шаблону".
	
OOoFBTools-1.26
1. Конвертер
	а). Исправил опечатку в названии меню и панели Виртуальных клавиатур на английском языке (Issue 65: Орфографическая ошибка в названии панели)
	б). Исправил баг - если в документе встречаются Разделы, и есть Концевые сноски, которые экспортируются, как Комментарии, то блок Комментариев не формировался в fb2-файле, что делало файл невалидным. Исправлено. Дополнительно исправлена ошибка с созданием блока Примечаний из "простых" сносок - в некоторых случаях возникал тот же баг, что и с Концевыми сносками. (Issue 64: Концевые сноски).
	в). Сделал представление данных поля "Programs used" более информативным - в зависимости от версии OooFBTools, например: 'OOoFBTools-1.26 (ExportToFB21)'. (Issue 67: Увеличить информативность поля program-used)
	г). НОВОЕ. Теперь меню OOoFBTools отображается и для Web-режима работы редактора (при открытии html-файлов). Панели не отображаются. Меню названо OOoFBTools. (с точкой), т.к. в файле Addons.xcu для разных контекстов (TextDocument, WebDocument и т.д.) меню нельзя назвать одинаково - не отображаются.
	д). В диалоге Настройки исправил баг - радиокнопки выбора метода сохранения Сносок - либо в Общий блок, либо в Разные блоки (Примечания и Комментарии) в некоторых случаях "залипали" - т.е. были выбраны обе. Теперь они работают, как переключатель.
	е). Внесены изменения в алгоритм сохранения сносок и Концевых сносок в разные блоки - Примечания и Комментарии. Теперь в каждом блоке сносок своя сквозная нумерация. (Issue 66: Некорректная нумерация сносок/примечаний)
	ж). Для экспорта Концевых сносок в отдельный от сносок блок ввел атрибут type="comment", по аналогии с type="note" для простых сносок.
	Например, после экспорта разных сносок в разные блоки (Примечания и Комментарии) текст получался так:
		<p>Test<a l:href="#n1" type="note">[1]</a></p>
		<p>test<a l:href="#c2">{2}</a></p>
	теперь будет так:
		<p>Test<a l:href="#n1" type="note">[1]</a></p>
		<p>test<a l:href="#c2" type="comment">{2}</a></p>
	Если же для Концевых сносок атрибут type="comment" не нужен, то аргументированно напишите, почему. Если возражения будут действительно серьезными - тогда type="comment" для Концевых сносок уберу.
2. Корректор Текста
	а). Оптимизирована опция "Вставляем пробел после знака препинания". Теперь для Профиля (Готовые Настройки) "Книги по Программированию" не "портятся" интернет-адреса.
	б). Оптимизация опции "Удалить пустые абзацы".
		Если в таблице есть пустой абзац, то при его удалении OpenOffice и LibreOffice "зависают" намертво - баг офиса.
		Если в тексте есть хоть одна Таблица, то абзацы не обрабатываются.
	в). Оптимизация опции "Заменить множественные пустые абзацы одним". Из-за несовершенства алгоритма (работаю над его улучшением), если в тексте есть Таблица или Текстовая Врезка, то в некоторых случаях они могу удалиться. Поэтому поставлена защита - если в тексте есть Таблица или Текстовая Врезка, то обработка не происходит. Со временем надеюсь переписать алгоритм заново без этих ограничений.
	
OOoFBTools-1.27
1. Общее
	а). Изменение места хранения файлов настроек для всех инструментов.
	Раньше они располагались то пути: C:\Documents and Settings\dikbsd\Application Data\OpenOffice.org\3\user\config\OOoFBTools (для Windows) и /home/dikbsd/.openoffice.org3/user/config/OOoFBTools (для Linux), а теперь - в домашней папке в папке .OOoFBTools, т.е. в D:\Мои документы\.OOoFBTools для Windows и /home/dikbsd/.OOoFBTools для Linux. Для MacOs X - аналогично. В примерах показана моя учетная запись (dikbsd), у вас в системе будет ваша.
	Чтобы сохранить все настройки инструментов просто перенесите файлы настроек из home/dikbsd/.openoffice.org3/user/config/OOoFBTools в /home/dikbsd/.OOoFBTools. Иначе при хапуске инструментов файлы настроек создадутся автоматически и инструменты придется настраивать заново.
2. Корректор Текста
	а). Уменьшены размеры формы Корректора, чтобы она могла полностью отображаться на ноутбуках и нэтбуках при разрешении 1024x768 pixels.
	б). Исправлена работа опции "Заменить кавычки  " " и “ ” на  « » ". Для этого в опции " Удалить пробелы внутри кавычек, например: « слова » -> «слова» " удалена обработка кавычек вида ", осталась только обработка кавычек “ ” и « ». (Issue 68: OOoFBTools-1.25 сломан фильтр отработки кавычек)
	в). Улучшена замена минуса между скобок на тире.
	г). Улучшена замена минуса на тире между русских слов.
	д). Для "Религиозной литературы" при нажатии одноименной кнопки включается опция "Заменить двойной минус (--) двойной дефис (––) на тире (Smart Режим Замены)", иначе не обрабатывается прямая речь.
	е). Улучшена обработка минусов и дефисов в прямой речи.
	ж). Улучшена работа опции "Заменить дефис или минус, используемый между слов вместо тире на тире"
	з). Исправлен баг - падение Корректора при удалении переноса, разорванного абзацем (Issues 71 http://code.google.com/p/ooofbtools/issues/detail?id=71)
	и). Улучшена обработка опций "Вставить пробел после знака препинания" и "Удалить пробел перед знаком препинания". Теперь "не портятся" листинги кодов, скрипты, интернет адреса и т.д. 
	к). Для "Книги по программированию" при нажатии одноименной кнопки отключаются опции "Удалить пробелы внутри скобок, например: ( слова ) -> (слова)" и "Удалить пробелы внутри кавычек, например: « слова » -> «слова»" для того, чтобы листинги кодов и скрипты "не портились".
3. Справка
	а). Новый раздел: "VI. Папка хранения всех служебных файлов (профили и настройки) всех инструментов OOoFBTools".
	
OOoFBTools-2.0
1. Общее
	а). В связи с координальным изменением кода работы с описанием книги в Конвертере номер данной версии OOoFBTools изменен на 2.0
2. Конвертер
	а). Теперь Конвертер работает и на портабельных сборках OpenOffice.org и LibreOffice на Windows.
	б). Изменение Настроек Конвертера вынесены в отдельный инструмент (на панели инструментов и в меню OOoFBTools)
	в). Принудительный экспорт в utf-8, если в тексте есть хоть один неразрывный дефис.
	г). Сделан "Редкатор FB2 свойств" для задания и редактирования описания Книги и сохранения данных в пользовательские свойства документа (Книги).
	д). Новая простая форма Конвертера.
	е). Уделены "Служебные стили" - они утратили свое назначение в связи с создание "Редактора FB2 свойств"
	ж). В Инструменте "Переопределения пользовательских стилей" удалены все Служебные стили, кроме Аннотации на Книгу.
	з). Новый файл стилей fb21_styles.ott. Удалены служебные стили: Для стилей абзаца - все, кроме "_Book Annotation". Для символьных стилей - все, кроме "code". Все данные, которые "описывали" удаленные Служебные стили теперь задаются и редактируются в новом диалоге "Редактора FB2 свойств". Таким образом, работа по заданию описания книги очень существенно упростилась.
	и). Удален инструмент Вставки Языка книги в служебную зону
	к). Удален инструмент Вставки Жанра книги в служебную зону
	л). Рефакторинг части кода.
	м). Внесены изменения в демонстрационные файлы ExportToFB21_example-1.odt и ExportToFB21_example-2.odt (удалены данные по Служебным стилям и в свойства файлов внесены fb2 свойства - описания)
	н). Файл стилей внедрен в расширение OOoFBTools, откуда и загружается автоматически при ативации Инструмента "Загрузка шаблона стилей в документ". Поэтому теперь нет нужды загружать файл стилей через Менеджер управления шаблонами (Файл-> Шаблоны->Управление). Работа со стилями упростилась :).
	о). Внесены значительные изменения в Справку - в части Стилей, подготовки документа к экспорту и задания описания книги (диалоги Настройки конвертера, Редактор fb2 свойств и Конвертер). Изменена структура Справки на более удобную и простую.
3. Корректор Текста
	а). Уменьшены размеры формы Корректора, чтобы она могла полностью отображаться на ноутбуках и нэтбуках при разрешении 1024x768 pixels.
	
OOoFBTools-2.1
I. Конвертер
	1. Исправлено несколько мелких ошибок по работе со стилями.
	2. Исправлена ошибка загрузки шаблона стилей в документ на Linux (Issues 77)
	3. В Редакторе fb2 свойств перенес поля для наиболее часто используемых данные вверх.
	4. В Редакторе fb2 свойств переделан алгоритм сохраниея и считывания свойств для обеспечения быстродействия, а также защиты от случайного удаления пользователем какого-нибудь свойства НЕ из Редактора fb2 свойств, а средствами OpenOffice или LibreOffice.
	5. Редактор fb2 свойств сделан немодальным. Т.е. теперь можно свободно копировать текст документа и вставлять его в поля Редактора, не закрывая его.
	6. Упрощены правила задания "Списочных" данных (Жанры, Авторы, Серии и т.д.).
		Например, для Авторов Книги:
		Добавление всех Авторов в Список производится нажатием кнопки "+". Но данные последнего Автора можно просто оставить в полях ввода, не добавляя их в Список нажатием кнопки "+".
		Если Автор Книги всего 1, то можно его данные оставить в полях ввода, не добавляя в Список нажатием кнопки "+".
		Т.е., при сохранении fb2-данных в свойства, вся информация в полях будет автоматически добавлена в Соответствующие Списки.
II. Разные инструменты
	1. Введена защита от повторного запуска во все инструменты, имеющие немодальные диалоги.
	
OOoFBTools-2.1.1
I. Конвертер
	1. Исправлены серьезные ошибки в работе конвертера и Редактора fb2 свойств.
	2. Улучшен дизайн и локализация Редактора fb2 свойств
	3. Загрузка fb2 свойств в Редактор и их сохранение отображается прогрессом (прогрессбар).
	
OOoFBTools-2.2
I. Конвертер
	А. Конвертер
		1. Исправил ошибку в названии кода одного Жанра (файл получался невалидным).
		2. Теперь конвертер корректно работает и на Windows 7
		3. Теперь конвертер корректно работает и на портабельных офисах на Windows XP и Windows 7 (валидация и экспорт картинок) (спасибо k_o-m за тестирование на 7-ке).
		4. Если в тексте были проставлены ударения над гласными русскими буквами Инструментом "Расстановке ударений над русскими гласными буквами", то документ конвертируется принудительно в utf-8 кодировке.
	Б. Редактор fb2-свойств
		1. Значительно увеличена скорость сохранения свойств в документ, за счет удаления кода принудительного сохранения документа, и введения признака изменения документа, что приведет к появлению стандартного сообщения о необходимости сохранения документа при его закрытии.
II. Инструменты Корректировки текста
	А. Новый инструмент: "Интерактивное создание сносок". Очень облегчает процесс создания сносок, список которых в распознанной книге расположен внизу страниц. Работа сводится к попеременному нажатию 2-х кнопок Инструмента. Между этими нажатиями пользователь просто проверяет, тот ли номер сноски был найден автоматически (из-за неточностей распознавания номеров сноски инструмент может найти следующую сноску, но это случается крайне редко.) . Подробности см. в Справке в иллюстрированном разделе "4.5. Интерактивное создание сносок" раздела инструментов корректировки текста.
	Б. Генератор Сносок
		1. Исправил баг - при генерации сносок стиль абзаца, куда вставлялась сноска, сбрасывался к по-умолчанию. тем самым нарушалось форматирование. Исправлено.
		2. Три инструмента по работе с Закладками были перенесены на НОВЫЙ диалог "Работа с закладками для Генератора Сносок" в виде 3-х кнопок. Подробности см. в Справке, в пункте 4.1.2.1. Диалог Работы с закладками для Генератора Сносок раздела инструментов корректировки текста.
		3. Исправлены несколько ошибок инструментов работы с закладками.
		4. При удалении закладок Генератора Сносок теперь документ приобретает атрибут "измененный" (Modified). Это не даст закрыть документ. не сохранив эти изменения.
	В. Корректор Текста
		1. Для опции "Вставить неразрывный пробел в сокращениях" добавил обработку дат.
	Г. Инструмент "Расстановка ударений над гласными русскими буквами" переделан в виде диалога с выбором символа-признака ударения в тексте. Это позволяет более гибко задавать признак ударения в документе, когда встречаются такие слова, как "О'Нил". В диалоге реализовано 3 варианта выбора символа - признака ударения: 1. Апостроф (') 2. Ударение (`) и 3. Другое. В 3-м случае в поле можно ввести символ(ы), но важно помнить, что они не должны совпадать с символами регулярных выражений: \, |, и т.д. В 3-м случае допускается вводить несколько символов.
III. Справка
	1. Новый раздел инструментов корректировки текста: "4.5. Интерактивное создание сносок"
	2. Новый  раздел инструментов корректировки текста: "4.1.2.1. Диалог Работы с закладками для Генератора Сносок"
	3. Обновлен раздел, посвященный Расстановке ударений над русскими гласными буквами.
	
OOoFBTools-2.3
I. Общее
	1. Разбил Панель инструментов FictionBook Tools на 2: FictionBook Tools и Вычитка. Теперь можно панель, инструменты которой используются не часто, закрыть.
II. Конвертер
	А. Конвертер
		1. НОВЫЙ Инструмент: Панель локализованных fb2 стилей. При первом ее запуске автоматически загружаются стили в документ. Позволяем делать разметку fb2 стилями. На Панели "собраны" только fb2 стили. Работать намного удобнее, чем с панелью стилей Офиса, где отображаются ВСЕ стили документа. и потом мучаешься в поисках нужного.
		2. Введены локализованные стили для следующих языков: Русский, Украинский, Белорусский, Английский, Немецкий, Французский. Испанский, Польский, Итальянский. Для всех остальных языков загружаются АНГЛИЙСКИЕ стили. Если надо еще локализовать стили - пишите.
		3. Удален Инструмент переопределния пользовательских стилей. Он теперь не нужен, т.к. есть Панель локализованных fb2 свойств.
	Б. Редактор fb2-свойств
		1. Внесены изменения в дизайн диалога.
		2. Исправил падение для инностранных (не русских) локализаций.
III. Инструменты Корректировки текста
	A. Генератор Сносок
		1. Исправил падение для инностранных (не русских) локализаций.
	Б. Инструмент "Отменить форматирование абзаца"
		1. Теперь работает более интеллектуально и корректно
		2. Позволяет производить сброс стилей и форматирования сразу в нескольких выделенных областях текста.
IV. Справочный материал
	А. Файлы-примеры ExportToFB21_example-1.odt и ExportToFB21_example-2.odt
		1. "Старые" стили заменены на "новые" - локализованные.
	Б. Справка
		1. Внесены изменения в части работы со стилями - Раздел II.А.1. Работа со стилями структуры документа

OOoFBTools-2.4
I. Конвертер
	А. Конвертер
		1. Для всех файлов стилей убрал Автообновление стилей. Теперь изменение, например, центрирования Цитаты не отразится на центрировании других Цитат.
II. Инструменты Корректировки текста
	А. Корректор Текста
		1. Опция "Вставить неразрывные пробелы между Фамилией и инициалами и наоборот". Если перед ФИО стоит перенос строки, а не новый абзац (обычно - в html файлах), то регулярные выражения в Офисе перестают корректно работать: поиск работеает, а на замену опция "регулярные выражения" никак не влияет. В результате текст портится. Скорее всего это глюк Офиса. Вставил дополнительные проверки для обеспечения ожидаемого результата замены.
		2. Опция "Заменить двойной минус (--) двойной дефис (--) на тире (Smart режим замены)". Если перед - стоит перенос строки, а не новый абзац (обычно - в html файлах), то регулярные выражения в Офисе перестают корректно работать: поиск работеает, а на замену опция "регулярные выражения" никак не влияет. В результате текст портится. Скорее всего это глюк Офиса. Вставил дополнительные проверки для обеспечения ожидаемого результата замены.

OOoFBTools-2.5
I. Конвертер
	А. Конвертер
		1. В файле-примере ExportToFB21_example-1.odt в Аннотацию на Книгу ввел форматирование (полужирный, курсив) и картинки с привязкой "как символ" для демонстрации фозможности конвертера экспортировать Аннотацию на Книгу с разными элементами и форматированием.
	Б. Панель fb2 стилей
		1. Сделана активация документа после задания тексту fb2 стиля и/или форматирования элементами панели. Т.е., теперь, после кликанья мышкой на списке fb2 стилей и/или кнопок "курсив" и т.д. управление передается обратно документу - не надо всякий раз кликать мышкой на документе. (Issue 80)
		
OOoFBTools-2.6
	А. Конвертер
		1. Для панели "fb2 стили" введены 2 новые опции: "Заголовки без полужирного" и "Заголовки без курсива". При их включении заголовок, к которому применяется один из стилей Заголовка будет без полужирного начертания и/или курсива.
		2. Исправление ошибок разметки fb2 стилями.
	Б. Инструменты Корректировки текста
		1. Новый инструмент "OCR ошибки форматирования". Часто после OCR распознавания текста, если в кавычках и/или скобках есть текст с курсивом, то сами кавычки/скобки распознаются тоже с курсивом, хотя в бумажной книге они - без курсива. Также при распознавании очень часто неверно форматируются курсивом знаки препинания, стоящие после слов/кавычек/скобок с курсивом.
			Данный инструмент ищет по тексту документа (сноски, таблицы и текстовые врезки не обрабатываются) вышеописанные OCR ошибки форматирования и снимает курсив со скобок, кавычек и/или знаков препинания. Используется интеллектуальный алгоритм определения, где курсив должен остаться, а где - это явная OCR ошибка.
			Инструмент позволяет опционально выбирать объекты исправления.
			
OOoFBTools-2.7
	А. Конвертер
		I. Панель "fb2 стили":
			1. Исправлены ошибки работы панели: вылет программы при форматированием стилями сносок, таблиц и текстовых врезок.
			2. Немного уменьшена высота панели для того, чтобы она хоть как-то помещалась в экран нетбуков. (Issues 90)
			3. Для кнопки "Code" введен сброс полужирного и курсивного начертания: имитации моноширинного текста он не нужны.
			4. Для обработки стиля Подзаголовок задействованы 2 опции: "Заголовки без полужирного" и "Заголовки без курсива". При их включении подзаголовок, к которому применяется стиль Подзаголовка будет без полужирного начертания и/или курсива.
	Б. Инструменты Корректировки текста
		I. Инструмент "OCR Errors Formating":
			1. Инструмент "OCR Errors Formating" переименован на английском в "OCR Formatting Errors" (Issues 89)
		II. Корректор Текста:
			1. В опцию "Вставить неразрывные пробелы между Фамилией и инициалами..." введена вставка неразрывного пробела до/после римских цифр и словом. Например: "XXV Олимпиада", "Карл XII" (Issues 92)
			
OOoFBTools-2.8
	А. Конвертер:
		1. Устранен вылет конвертера на последних версиях LibreOffice и Apache OpenOffice.
	Б. Инструменты Корректировки текста
		I. Корректор Текста:
			1. Устранен вылет Корректора Текста на последних версиях LibreOffice и Apache OpenOffice.
			2. Обработка регулярных выражений в Apache OpenOffice и LibreOffice не одинакова, увы. Для Apache OpenOffice исправлена ошибка работы опций "Удалить пробелы внутри скобок, например: ( слова ) -> (слова)"  "Удалить пробелы внутри кавычек, например: « слова » -> «слова»", когда вместо удаления пробелов внутри кавычек и скобок происходило дублирование части текста. Это - проблема Apache OpenOffice (на LibreOffice код работал прекрасно). (issue 91, issue 93, issue 94)
			3. Удалил опцию "Заменить множественные пустые абзацы на один". Не работала, как надо, а в некоторых случаях удалялась графика,  когда она обрамлялась пустыми абзацами.
			4. Мелкие улучшения.
		II. Генератор сносок:
			1. Добавлено 7 шаблонов поиска идентификатора текста сноски в документе для "Простой генерации сносок" и 7 шаблонов поиска идентификатора номера сноски в документе для "Сложной генерации сносок".

OOoFBTools-2.9
	А. Инструменты Корректировки текста:
		I. Склейка разрыва строк и абзацев...
			1. Исправил ошибку - падение инструмента.
		II. OCR ошибки форматирования...
			1. Улучшена обработка курсива скобок и кавычек. Время работы инструменто увеличилось...
			
OOoFBTools-2.10
	А. Конвертер:
		1. Скорректирована работа инструментов конвертера для LibreOffice 4.0 и выше (из-за изменения API  в LO 4.0 панель fb2 стилей не работала).
	Б. Инструменты Корректировки текста:
		1. Инструмент "OCR ошибки форматирования"
			а). Теперь инструмент исправляет ошибки форматирования после OCR во всех объектах документа (текст, сноски, таблицы и текстовые врезки).
			б). Рефакторинг и оптимизация кода.

OOoFBTools-2.11
	А. Инструменты Корректировки текста:
		1. Инструмент "Интерактивное преобразование № примечаний по шаблону" (часто используется для поиска номеров сносок в верхнем индексе или любых символов в верхнем индексе)
			а). Теперь инструмент "не падает" на таблицах, врезках и сносках.
		2. Инструмент "Нумерация выделенных абзацев"
			а). Теперь инструмент обрабатывает не только текст, но и Таблицы, Врезки и Сноски. Если нет ни одного выделения в документе, то пронумеровываются все абзацы текста.
		3. Инструмент "OCR ошибки форматирования"
			а). Улучшен алгоритм обработки.
		4. Инструмент "QWERT -> ЙЦУКЕ -> QWERT"
			а). Изменение алгоритма обработки символов. Улучшена обработка знаков препинания/
			б). Теперь инструмент может обрабатывать любое число выделенных фрагментов текста.
			в). Теперь инструмент может обрабатывать не только текст, но и Таблицы, Текстовые Врезки и Сноски.
		5. Инструмент "Вставка • в начало заданных абзацев"
			а). Теперь инструмент может обрабатывать не только текст, но и Таблицы, Текстовые Врезки и Сноски.
		6. Инструмент "Обработка множественных пробелов и табуляций"
			а). Теперь инструмент может обрабатывать не только текст, но и Таблицы, Текстовые Врезки и Сноски.
		7. Инструмент "Ручная обработка абзацев"
			а). Теперь инструмент может обрабатывать не только текст, но и Таблицы, Текстовые Врезки и Сноски.
		8. Инструмент "Склейка разрывов строк и абзацев..."
			а). Теперь инструмент может обрабатывать не только текст, но и Таблицы, Текстовые Врезки и Сноски.
		9. НОВЫЙ инструмент: "Автоматическая разметка листингов программ":
			Инструмент применяется для автоматической разметки листингов программ в тексте документа. Принцип работы прост: инструмент ищет текст стиля 'Текст в заданном формате' (Preformatted Text) и заменяет этот стиль на стиль 'code'.
			
OOoFBTools-2.12
	А. Конвертер:
		1. Починил экспорт листингов программ, размеченных стилем 'code'.
		2. Все пробелы в листингах автоматически заменяются на неразрывные пробелы, сохраняя тем самым структуру листингов программ для многих читалок.
		3. НОВОЕ: Экспорт всей векторной графики из OpenOffice Writer / LibreOffice Writer (Выноски, Фигуры, Блок-схемы, Блочные стрелки, Линии, Кривые Безье, Шэйпы, Art Text (Текстовые эффекты) и т.д.). Работает как для текста (текст, таблицы, врезки, сноски), так и для обложек.
		4. НОВОЕ: Выбор режима экспорта размеров графики: 1. "оригинал": размер, как тексте документа. 2. Логический размер объекта. 2-й вариант дает более качественное изображение, но размер несколько больше чем в 1-м варианте экспорта. Опции выбора находятся в Диалоге Настроек Конвертера в блоке "Экспорт графики".
	Б. Инструменты Корректировки текста:
		1. Инструмент: "Автоматическая разметка листингов программ":
			а). Исправил досадный баг - на английской локализации инструмент падал.
		2. Инструмент: "Корректор текста...":
			а). Введена опция подключения/отключения замены неразрывных пробелов на такое же число простых при обработке пробелов в тексте. По-умолчанию включена для всех профилей, кроме технических, компьютерных книг и книг по программированию. Отключение опции позволит сохранить в листингах программ неразрывные пробелы, которые были сгенерированы инструментом "Автоматическая разметка листингов программ".
			
OOoFBTools-2.13
	А. Конвертер:
		1. В диалоге Настроек можно задавать параметры экспорта jpeg картинок:
			а). Цветовой режим экспорта jpeg: В Цвете (Color) или в градациях Серого (Grayscale).
			б). Выбор качества экспорта jpeg картинок от 100 до 5 с шагом 5 (100 - максимальное качество/минимальное сжатие, 5 - минимальное качество/максимальное сжатие)
		2. В диалог "О пакете OOoFBTools..." добавлены данные о поощрении (donate)

OOoFBTools-2.14
	А. Общее
		1. Группировка инструментов в меню и на панелях инструментов по более логическому, функциональному признаку.
		2. Добавлен логотип расширения и данные для обновления/загрузки (видно в менеджере расширений). 
	Б. Конвертер:
		1. Панель fb2 стилей.
			а). На некоторых операционных системах на LibreOffice 4 открытие панели/загрузка fb2 стилей занимало очень много времени. Исправлено.
		2. Исправлен баг: Если документ имеет ссылки на диаграммы и/или формулы, а также другие OLE объеты, но самих этих объектов в документе нет (обычно это бывает при вставке скопированного текста с сайта), то конвертер "падал". Исправлено.
		3. Иконка конвертера изменена на новую.
		4. В LO4 из-за координального изменнения API многие инструкции и функции для макросов стали работать неверно (например, инструкция Mid). В результате чего в экспортируемый текст помещался "мусор", в виде нечитаемых NULL и случайного набора символов. Из-за этого в ряде случаев полученный fb2-файл оказывался невалидным. Некоторый код конвертера пришлось переписать, чтобы обойти эти баги LO4.
	В. Инструменты Корректировки текста:
		1. НОВЫЙ Инструмент: "Ёфикация текста". Служит для простановки букв "ё" ("Ё") в словах русского языка. База слов - большая, поэтому работа Ёфикатора может затянуться на долго, в зависимости от объема текста (от нескольких секунд до нескольких десятков минут).
		Неоднозначные слова, которые могут быть и с буквой "е" и с буквой "ё" (например: все - всё; белено'й - белёной) не обрабатываются.
		2. Инструмент "OCR ошибки форматирования"
			а). Исправлены ошибки русской локализации.
			б). Введена защита: Если все опции корректировки отключены, то кнопка Обрабоки становится недоступной.
		3. Удаление устаревшего Инструмент "Преобразование № примечаний в верхнем индексе по шаблону".
		Он требовался для подготовки текста для Генератора сносок, когда тот еще не умел работать с номерами сносок в верхнем индексе.
		
OOoFBTools-2.15
	А. Общее:
		1. Справка.
			а). Полностью переписан раздел Справки, посвященных работе с инструментом Интерактивного создания сносок. Приведена иллюстрированная пошаговая методика генерации сносок.
	Б. Конвертер:
		1. Ввел защиту при обработке больших строк...
	В. Инструменты Корректировки текста:	
		1. Корректор Текста.
			а). Улучшение работы опции "Заменить множество пробелов между словами на..." (исправление проблем LO4).
			- Добавлена обработка и множества табуляций между словами.
		2. Инструмент "Интерактивное создание сносок".
			а). Новая кнопка "0. Выделить текст сноски". Ставим курсор в любое место теста сноски, нажимаем на эту кнопку  - выделяется абзац текста сноски (ингорируются ее номер в верхнем индексе и все пробелы/табуляции между номером сноски и самим текстом сноски). Так удобнее, чем выделять текст мышкой.
			б). Значительно улучшена работа и удобство использования инструмента.
			- Часто после OCR 2-х значные, 3-х значные и т.д. номера сносок в верхнем индексе получаются не одним числом (например, 123), а двумя числами, стоящими рядом, (хотя они выглядят, как одно неразрывное число (например, 1 и 23) ). Раньше инструмент находил только первое такое число, что вызывало неудобство при последующей генерации сносок - приходилось перемещаться с числа 23 на 124 (в нашем примере). Теперь инструмент стал интеллектуальным, и выделяет все идущие подряд номера сносок в верхнем индексе (в нашем примере будут выделены сразу рядомстоящие число 1 и 23).
			- При вставке с помощью кнопки инструмента текста сноски из буфера. теперь происходит не просто переход на текст следующей сноски. но и выделение текста сноски. Причем. сам номер сноски и пробелы до текста игнорируются. Выделяется только 1 абзац. Стало более удобно работать.
			- Новая кнопка - "Выделение цветом номеров сносок для наглядности" - желтая кнопка с текстом "123". Используется для того, чтобы выделить номера сносок в тексте красным цветом и желтым маркером, а номера сносок в списках сносок - красным цветом и голубым маркером. Гораздо удобнее ориентироваться при работе с инструментов, когда сноски "подсвечены".
			- Внесены изменения и дополнения в Справке для этого инструмента.
			- По сути дела алгоритм работы инструмента теперь таков: Выделяем текст 1-й сноски с помощью кнопки "0. Выделить текст сноски". Нажимаем кнопку "1. Вырезать в буфер". Автоматически перешли на ее номер в тексте книги (выделение). Нажимаем кнопку "2. Вставить сноску" - сноска вставляется и автоматически делается переход на текст следующей сноски (выделение). И так далее... Подробнее см. Справку.
		3. Генератор Сносок.
			а). Генератор сносок в режиме "Простая генерация сносок по шаблону":
				- Исправлена ошибка - зависание при обработки текста существующих сносок.
				- Сделана возможность поиска многоабзацевого текста в границах идентификаторов (шаблон). Раньше алгоритм находит только однообзацевый текст текста для сноски.
			б). Генератор сносок в режиме "Сложной генерации":
				- Значительно улучшена интеллектуальность Генератора. Часто после OCR 2-х значные, 3-х значные и т.д. номера сносок в верхнем индексе получаются не одним числом (например, 123), а двумя числами, стоящими рядом, (хотя они выглядят, как одно неразрывное число (например, 1 и 23) ). Раньше инструмент находил только первое такое число, что вызывало неудобство при последующей генерации сносок - приходилось перемещаться с числа 23 на 124 (в нашем примере). Теперь инструмент стал более интеллектуальным, и выделяет все идущие подряд номера сносок в верхнем индексе (в нашем примере будут выделены сразу рядомстоящие число 1 и 23).
			в). Улучшение стабильности, информативности и удобства анализа данных Теста сложной генерации сносок.
			
OOoFBTools-2.16
	А. Инструменты Корректировки текста:
		1. Корректор Текста.
			а). Для LibreOffice 4+ восстановлено удаление мягких переносов.
			
OOoFBTools-2.17
	А. Инструменты Корректировки текста:
		1. Корректор Текста.
			а). Для LibreOffice 4+ исправлена ошибка: при удалении пробелов между кавычкой и слово удалялись пробелы между любым символом и английской буквой "B" (баг LO4+). Исправлено.
	Б. Конвертер:
		1. Улучшена обработка листингов программ.
		Теперь в диалоге Настройки (группа "Разное") появилась опция "Шрифт "Courier New", как определитель листингов программ". По умолчанию выключена. При ее включении конвертер будет воспринимать весь текст с шрифтом "Courier New", как указатель на то, что это - код листингов программ или моноширинный текст, и, соответственно, такой текст будет экспортирован в тэгах <code>.
		В предыдущих версиях OOoFBTools конвертер автоматически воспринимал любой текст с этим шрифтом, как листинги программ, что приводило к тому, что книга, не являющаяся листингом, но текст которой набран шрифтом "Courier New" экспортировался , как листинг.
		Теперь этим можно управлять новой опцией в Настройках.

OOoFBTools-2.18
	А. Конвертер:
		1. Улучшена обработка листингов программ.
	Б. Инструменты Корректировки текста:
		1. Автоматическая разметка листингов программ:
			а). Введена возможность выбора критерия идентификации текста, как листинга программы: Шрифт для абзацев, Стиль для абзацев, Шрифт для символов и Стиль для символов.
			При выборе критериев для Символов, инструмент отформатирует отдельные слова стилем code и шрифтом Courier New.
			При выборе критериев для Абзацев, инструмент отформатирует найденные абзацы стилем code и шрифтом Courier New, а также заменит в этих абзацах множественные простые пробелы на неразрывные.
			
OOoFBTools-2.19
	А. Конвертер:
		1. НОВОЕ: В выбор схемы Жанров добавлена схема от Либрусек с гораздо бОльшим числом жанров.
		2. Исправил ошибку - данные о диалоге задания fb2 свойств конвертера сохранялись не по нажатию кнопки "Сохранить FB2 свойства", как должно было быть, а по выходу. Исправлено.
	Б. Валидатор:
		1. Новое: В Валидаторе предусмотрен выбор FictionBook схемы. Схема «fb2 LibRusEc» отличается от fb2.1 и fb2.2 только гораздо бОльшим списком разрешенных жанров. При валидации будьте внимательны при выборе схемы Жанров. Если книга сделана с поддержкой списка жанров Либрусек, и в книге есть Жанры, присущие только этой схеме, а вы в Валидаторе выбрали схему «fb2.1» или «fb2.2», то Валидатор сообщит о невалидности проверяемого fb2-файла (и будет абсолютно прав).
	В. Справка:
		1. Изменения и дополнения в части конвертации - выбор схемы Жанров.
		2. Изменения и дополнения в части "Валидатор" - выбор схемы Жанров.
	Г. Огромная благодарность Дмитрию (Dmitri Gabinski) за помощь в переводе истории изменения на английский язык.
	
OOoFBTools-2.20
	А. Конвертер:
		1. Исправлен старый баг в работе с Жанрами.
		2. НОВОЕ: Для Linux, FreeBSD, Mac OS X и других *nix систем сделана возможность валидации fb2-файла после экспорта (опция включения/отключения находится в Настройках конвертера). Ранее валидация работала только для Windows.
		Для валидации fb2 файла на Unix системах должна быть установлена утилита xmllin (обычно она включена в пакет libxml2-utils).
		3. Приведение сообщений о результате проверки fb2-файла на валидность к одному виду для всех операционных систем.
	Б. Инструмент Валидатор:
		1. НОВОЕ: Для Linux, FreeBSD, Mac OS X и других *nix систем сделана возможность валидации выбранного fb2-файла. Ранее валидация работала только для Windows.
		2. Приведение сообщений о результате проверки fb2-файла на валидность к одному виду для всех операционных систем.
	В. Инструменты Корректировки текста:
		1. Нумерация выделенных абзацев:
			а). После номера добавляется неразрывный пробел.
		2. Вставка маркера в начало заданных абзацев:
			а). После маркера добавляется неразрывный пробел.
			б). Значительно расширен список вставляемых маркеров.
			
OOoFBTools-2.21
	А. Конвертер:			
		1. Критическое обновление: исправление ошибки генерации картинок для Win 7/8
		
OOoFBTools-2.22
	А. Общее:
		1. По просьбам пользователей из Украины для LibreOffice / Apache OpenOffice с украинской локалью отображаются названия меню, панелей инструментов и сообщения всех инструментов и конвертера на русском, а не на английском языке.
		2. В диалог "О пакете инструментов OOoFBTools" добавил информацию о сайтах расположения OOoFBTools для скачивания новых релизов.
	Б. Инструменты Корректировки текста:			
		1. Корректор Текста:
			а). Критическое обновление: исправление ошибки вставки неразрывного пробела в сокращениях.
		2. Интерактивное создание сносок:
			а). Улучшение работы инструмента.
		
OOoFBTools-2.23
	А. Инструменты Корректировки текста:
		Критическое обновление: На LibreOffice 4.x и Apache OpenOffice 4.x "сломан" механизм поиска и замены в регулярных выражениях, что приводит к "порче" текста документа.
		1. Корректор Текста:
			а). Исправление ошибки работы опции "Заменить дефис или минус, используемый между слов вместо тире на тире". Исправлено.
			б). В замену множественных пробелов между словами одним пробелом/табуляцией введено игнорирование цифр в верхнем/нижнем индексе. Иначе первая же буква после таких цифр преобразовывалась верхний/нижний индекс.
		2. Ошибки OCR форматирования:
			а). Улучшение работы инструмента при обработке кавычек - защита от зацикливания.
			
OOoFBTools-2.24
	А. Конвертер:			
		1. Новое: Экспорт вложенных маркерованных/нумерованных/графических списков в тексте, врезках, таблицах. Вложенность иммитируется неразрывными пробелами, число которых можно задавать в Настройках конвертера. По-умолчанию принято 3 неразрывных пробела.
	Б. Инструменты Корректировки текста:
		1. Корректор Текста:
			а). Улучшена работа опции "Заменить минус на короткое тире между цифрами". Теперь она заменяет на короткое тире не только минус, но и дефис и тире. Опция переименована в "Заменить минус, дефис, тире на короткое тире между цифрами".
			
OOoFBTools-2.25
	А. Конвертер:			
		1. Новое: Для всех операционных систем сделана генерация полноценного GUID для ID fb2 файла. Если по какой-либо причине GUID не смог сгенерироваться (не найдена утилита uuidgen для Mac OS X, Linux и/или другой системы, кроме Windows, или другая причина), то генерируется GUID на основе времени и генератора случайных чисел.
		Для Windows ничего дополнительно устанавливать не надо (утилита генерации находится в самом расширении OooFBTools). Для Mac OX X, Linux и других Unix систем надо установить утилиту uuidgen. Обычно она установлена по-умолчанию в дистрибутивах систем. Проверить это можно, выполнил в терминале команду: uuidgen. Если uuidgen установлена, то отобразится GUID. Если ее нет в системе, то нужно установить пакет uuid-runtime или libuuid1.
		2. Улучшение эргономики формы Редактора fb2 свойств.
		3. Упрощена пост-обработка: чистка сгенерированного fb2 кода.
		4. Немного уменьшен размер диалога Настроек для работы на ноутбуках.
	Б. Инструменты Корректировки текста:
		1. Интерактивное создание сносок:
			а). Новое: Теперь инструмент может работать с номерами примечаний не только в виде цифр в верхнем индексе, но и в виде цифр с точкой (без индекса). Например: "4. Текст примечания". Введен режим поиска номеров примечаний в списках примечаний: 1. в виде цифр с точкойЖ 2. В виде цифр в верхнем индексе. Цветовая разметка номеров примечаний в тексте и в списках примечаний также зависит от выбора режима поиска.
		2. Корректор Текста:
			а). НОВОЕ: Добавлена возможность вставки неразрывного пробела между датой и месяцем, например, 19 января, January 19...
			б). Уменьшен размер формы, чтобы она помещалась на экранах ноутбуков 15'4 1366x768. Для этого опции Корректора разнесены на 2 "вкладки"-переключатели: "Пробелы, абзацы и разрывы" и "Дефисы, тире и другое".
			
OOoFBTools-2.26
	А. Конвертер:
		1. В связи с тем, что Open Office и Libre Office по-разному воспринимают форматирование текста, была усовершенствована обработка "пустых" тэгов вида </strong><strong>, <sup/><sup> и т.д. Теперь ни одного "пустого" тэга в сконвертированном fb2 не остается, не зависимо от используемого Офиса.
		2. Улучшена обработка листингов программ, если в них есть текст с маркерами/нумерованными списками.
	Б. Инструменты Корректировки текста:
		1. Корректор Текста:
			а). На вкладке "Дефисы, тире и другое" добавлена НОВАЯ группа "Нумерованные и маркерованные списки" с опцией "Заменить маркеры Тире и Дефисов в прямой речи на Тире или Дефис". По-умолчанию опция отключена. Она актуальна для литературы, где есть прямая речь (художественная литература).
			Опция позволяет учитывается особенность OCR текста: Часто при распознавании текста символы прямой речи (Длинное Тире —, Среднее Тире –, Цифровое тире, Дефис, Дефис-Минус -) воспринимаются OCR инструментом (FineReader), как маркеры списка. И при конвертировании такая прямая речь с маркерами может восприняться конвертором не как прямая речь, а как маркерный список, и перед маркером будет добавлено несколько пробелов (задается в Настройках конвертера). Включение же этой опции при корректировке текста Корректором заменит маркеры в прямой речи на эквивалентные символы и уберет признак маркерного списка в таких абзацах.
			Для профиля "Художественная литература" опция "Заменить маркеры Тире и Дефисов в прямой речи на Тире или Дефис" включается автоматически. Для остальных профилей - отключается. Но для любого профиля ее можно включить/отключить вручную.

OOoFBTools-2.27
	А. Конвертер:
		1. Добавлена поддержка схемы жанров сайта Флибуста (диалог задания fb2 свойств Конвертера и в диалоге Избранных жанров).
		2. Мелкие доработки конвертера по генерации более корректной семантики тэгов.
	Б. Валидатор:
		1. Добавлена поддержка схемы жанров сайта Флибуста.
	В. Инструменты Корректировки текста:
		1. Ёфикатор:
			а). Обновлена база слов: теперь слово "отеле" не заменяется на "отёле". Это слово отнесено к неоднозначным словам.
			
OOoFBTools-2.28
	А. Общее:
		1. Версия лицензии исправлена на GPLv3.
		2. Обновление Справки в частях  разделов описания инструментов, для которых были внесены корректировки.
	Б. Конвертер:
		1. Панель fb2 стилей:
			а). Новая опция: "F1... F10 для Заголовков". При включении опции нажатие разметку Заголовков стилями Заголовок 1 ... Заголовок 10 можно производить нажатием функциональных кнопок F1... F10. Эти кнопки будут срабатывать только при открытой панели Fb2 стилей! При закрытии панели fb2 стилей кнопки F1... F10 перестают выполнять функцию разметки стилями Заголовок 1 ... Заголовок 10, и "возвращаются" к своему первоначальному состоянию. Это же происходит и при снятии галочки с опции "F1... F10 для Заголовков" на открытой панели fb2 стилей.
		2. Исправлен баг: при экспорте концевых сносок fb2 получался невалидным.
		3. При конвертировании документа с картинками теперь не надо вручную перезагружать Офис, чтобы картинки могли корректно экспортироваться. Конвертер сам это делает автоматически. Перезагрузка происходит только для документа, содержащего растровую или векторную графику, а также текстовые врезки.
		4. Улучшен ввод Даты написания книги. Раньше, при некорректном вводе этой даты fb2 получался невалидным.
		Дата (текст) задается так: ГГГГ. Дата (значение) - так: ГГГГ-ММ-ДД. Для наглядности введено отображение формата ввода данных для Дата (текст) и Дата (значение). Также при сохранении введенных fb2 свойств документа введена проверка на соответствие Даты написания книги этому формату и диапазону, в который должны укладываться даты каждого месяца, а сами месяцы должны быть в диапазоне от 01 до 12.
	В. Инструменты Корректировки текста:
		1. Корректор Текста:
			а). Улучшена работа всех опций по обработке минуса, тире и дефиса. Теперь учитывается их комбинации с неразрывными пробелами.
			б). Новая опция: "Заменить дефисы и минусы в прямой речи на тире".
			в). Исправлен баг: В словах вида "Да-а-а", "э-э-э"  и т.д. только первое тире (минус) заменялось на короткое тире. Теперь заменяются все тире, минусы.
		2. НОВЫЙ инструмент: Интерактивное преобразование вложенных таблиц в текст. Инструмент будет полезен при конвертации в fb2 формат документа, содержащего вложенные таблицы (конвертер такие не экспортирует).
		3. Инструмент "Склейка разорванных строк абзаца":
			а). Улучшение алгоритма работы.
			б). НОВАЯ возможность склейки разорванных строк абзаца: "Отступ в начале абзаца (Красная строка)". Подробности см. в разделе Справки для инструмента склейки разорванных строк.
			в). НОВАЯ возможность склейки разорванных строк абзаца: "Разрыв предложений в абзаце на строчных буквах, цифрах, знаках препинания, кавычках и скобках". То есть, ДО разрыва может находиться любая буква (строчная или ПРОПИСНАЯ), закрывающая кавычка лапка или ёлочка, закрывающая скобка любого типа или же знак препинания (;:,). Но, как следует из названия инструмента, если после разрыва предложения находится слово, первая буква которой - ПРОПИСНАЯ, то склейки разрыва не произойдет. Это ограничение алгоритма введено для того, чтобы случайно не склеились абзацы и заголовки Разделов текста.
		4. Инструмент "Интерактивное создание сносок":
			а). Улучшена интеллектуальность алгоритма.
			
OOoFBTools-2.29
	А. Конвертер:
		1. Улучшена обработка картинок для html-файлов, в которые встроена графика, как base64 код (Open/LibreOffice такие html не может правильно открыть и отобразить, и картинка отображается в тексте документа, как base64 код). Конвертер "падал" на таких файлах.
		2. Улучшена обработка слишком длинных строк в документе - конвертер "падал" в некоторых случаях.
		3. Исправлен старый баг: Если OOoFBTools только что установлен (нет файла с настройками), то экспорт получался не корректным (не было названия Блока Примечаний. неверно экспортировались врезки - в виде таблиц, а не структур...). Исправлено.
		4. В версии 2.28 был сломан экспорт сносок, текст которых - сложные структуры. Исправлено.
		5. Перезапуск документа при экспорте теперь происходит только при наличии в документе растровой	графики (наличие в тексте векторной графики и текстовых врезок теперь не является условием для переоткрытия документа при конвертировании. )
		6. Введена проверка на наличие существующего fb2 файла. На форме экспорта добавлен контрол-"галочка", включение которого (по-умолчанию) приводит к перезаписыванию существующего fb2 файла на новых, генерируемый конвертером. Если "галочка" снята, и fb2 файл уже есть, то выдается сообщение о необходимости изменить название генерируемого fb2 файла.
		7. Увеличено число видов экспортируемой векторной графики.
		8. НОВОЕ: Теперь, если в документе в одном и том же абзаце есть несколько закладок, и на них есть ссылки из разных частей документа, то все эти ссылки "приведут" на этот абзац. Раньше в данной ситуации работала только одна ссылка, а остальные "вели в никуда".
	В. Инструменты Корректировки текста:
		1. Корректор Текста:
			а). НОВАЯ опция: Встраивание графики в документ. Очень полезна для работы с текста, которые содержат ссылки на графику, расположенную на жестком диске. При включенной опции Корректор Текста встраивает такие картинки прямо в текст (с жесткого диска их можно будет удалить). Иными словами - картинки после обработки располагаются в документе. Опция по-умолчанию включена для всех профилей Корректора.
			б). Улучшена логика обработки знаков препинания, кавычек, скобок и минуса, тире, дефиса. Это особенно актуально для текста, распознанного последним релизом FineReader 2012.
		2. НОВЫЙ инструмент: "Удаление всех объектов в документе". Позволяет по выбору удалять все объекты:
			1). Текстовые врезки;
			2). Таблицы (все или только вложенные в ячейки других таблиц). Удаляются и таблицы с защищенными ячейками;
			3). Закладки (все или только неиспользуемые - на которые не ссылается никакой объект в документе);
			4). Растровую графику;
			5). Векторную графику;
			6). Встроенные объекты (OLE, диаграммы, формулы, презентации, электронные таблицы, блок-схемы, LineArt надписи и т.д.).
		
OOoFBTools-2.30
	А. Корректная локализация инструментов на английский язык (огромная благодарность Дмитрию Габинскому):
		1. Поиск OCR ошибок в тексте.
		2. OCR ошибки форматирования.
		3. Склейка разрыва строк и абзацев.
	Б. Конвертер:
		1. Исправлен баг: LibreOffice перестал "видеть" локализованный стиль Цитата, то есть, стал воспринимать только Quotations (OpenOffice по-прежнему корректно работает в локализованным стилем Цитата). Это приводило к тому, что Цитаты не экспортировались. Исправлено.
		2. Полностью переделана загрузка стилей в документ. Теперь стили не загружаются из шаблонов, а создаются при первом открытии панели fb2 стилей. Это позволило обойти "старый" баг LibreOffice, когда на Windows 7.x/8.x стили могли загружаться десятки минут, в зависимости от размера документа. Теперь панель fb2 стилей запускается почти мгновенно на любой операционной системе.
		3. Редактор fb2 свойств:
			а). НОВОЕ: На вкладку данных описания бумажной книги добавлены поля для ввода УДК, ББК и Авторского знака.
		4. Диалог внесения описания книги (fb2 свойств):
			а). НОВОЕ: на вкладке Custom Info добавлен выпадающий список с готовыми типами пользовательских типов: copyright, editor и т.д.
	В. Инструменты Корректировки текста:
		1. Инструмент "Вставка выбранного символа маркера в начала заданных абзацев":
			а). Исправлен баг, при котором в некоторых случаях удалялась первая буква абзаца.
		2. НОВЫЙ инструмент: "Форматирование документа". Позволяет отформатировать документ по заданным критериям: размер и ориентация страниц, отступы от границ абзацев, шрифт и размер шрифта, встраивание графики-ссылок в документ и многое другое.
		
OOoFBTools-2.31
	А. Корректная локализация инструментов на английский язык (огромная благодарность Дмитрию Габинскому):
		1. Корректор текста
		2. Отменить форматирование абзаца
		3. Расстановка ударений над русскими гласными буквами
		4. QWERT -> ЙЦУКЕ -> QWERT
		5. Ручная обработка абзацев
	Б. Конвертер:
		1. Панель fb2 стилей
			а). Добавлено создание стиля code для абзаца и символов.
	В. Инструменты Корректировки текста:
		1. Восстановлена работа инструмента "Отменить форматирование абзаца"
		2. Инструмент "Корректор Текста":
			а). Для всех опций работы с минусами, дефисами и тире введена обработка минуса(U+2212).
			б). Удалены опции работы с графикой.
		3. Инструмент "Автоматическая разметка листингов программ"
			а). Исправлен вылет инструмента.
		4. Инструмент "Форматирование документа":
			а). Новые опции, позволяющие для всей графики в документе изменить привязку, обтекание, горизонтальное и вертикальное выравнивание.
			
OOoFBTools-2.32
	А. Конвертер:
		1. Сгенерированный fb2 файл не проходил валидацию на жанре ЛитРПГ (sf_litrpg) схемы Флибуста. Исправлено.
		2. Панель fb2 стилей:
			а). Исправлен алгоритм создания стилей. Есть ситуации, когда документы, обрабатываемые на старых версиях OOoFBTools, продолжают форматироваться fb2 стилями на новых версиях OOoFBTools. Из-за бага LO стиль Цитата в документе не создается. Поэтому в таких документах при работе с fb2 стилями стиль Цитата отсутствует.
			Исправил. Теперь стиль Цитата создается и для документов, которые начинали править на старых версиях OOoFBRools, и продолжают на новых версиях OOoFBTools.
	Б. Инструменты Корректировки текста:
		1. Инструмент "Форматирование документа":
			а). Новая опция, задающая интервал для символов, равным 0 (убрать разрядку или сжатие).
			б). Новая опция, задающая 100% масштаб символов по ширине.
		2. В новой версии LO 4.4.0 перестал работать инструмент "Форматирование текста". Исправлено.
		3. В новой версии LO 4.4.0 перестал работать инструмент "Удаление объектов". Исправлено.
		
OOoFBTools-2.33
	А. Конвертер:
		1. Исправлена ошибка: Если между двумя Заголовками находится только картинка, то fb2 файл получался невалидным. Теперь после нее вставляется пустой абзац.
		2. Исправлена ошибка: В тексте сносок есть только Заголовки (в нарушение схемы). Сделана защита от такой ситуации.
		3. Исправлена ошибка: В некоторых случаях не работал алгоритм генерации ссылки из разных абзацев на разные части одного и того же абзаца. Переписал заново алгоритм. 
		4. Улучшен экспорт сносок с сылками.
		5. В диалоге экспорта при отображении хода работы конвертера теперь отображается результат для каждого шага. То есть отображается чило экспортированных обложек, сносок и т.д.  (пожелание https://sourceforge.net/p/fbtools/bugs/17/)
		6. Панель fb2 стилей
			а). Для стиля code добавлена функциональность. Теперь при задании стиля code листингам программ все множественные простые пробелы внутри текста, а также все одиночные и множественные стартовые пробелы заменяются на неразрывные пробелы.
		7. Настройки конвертера:
			а). Удалил опцию "Обработать "пустые" тэги (</x><x>, <x></x>, </x> <x> и <x> </x>)". (удаление в сгенерированном fb2-файле комбинаций тегов вида <strong/></strong>, </strong><strong>, <strong/> </strong>, </strong> <strong> и т.д.). Теперь в полученном fb2-файле всегда удаляются подобные комбинации тэгов.
			б). Новая опция: Группа "Предварительная обработка текста", опция "Удаление неиспользуемых закладок (на них ничто не ссылается) во всем Документе". По умолчанию отключена. Опция предназначена для удаления из документа всех закладок, на которые ничто не ссылаются. Иначе в полученном fb2-файле эти закладки будут сконвертированы в аттрибуты id тэгов <p>/ F? поскольку, на них ничто в тексте не ссылается, то эти аттрибуты будут избыточными.
			Если опция включена в Настройках, то после предварительной обработки текста документ будет автоматически сохранен и перезагружен. Появится диалог экспорта в fb2-формат.
		8. Редактор fb2 свойств:
			а). Теги описания книги для УДК, Авторского знака теперь имеют аттрибуты и на английском, и на русском языке (Пожелание https://sourceforge.net/p/fbtools/enchancements/4/)
	Б. Инструменты Корректировки текста:
		1. Инструмент "Автоматическая разметка листингов программ":
			а). Изменен алгоритм. Теперь при анализе текста и разметке листингов программ в непрерывные пробелы преобразуются не только множественные пробелы в пределах листингов программ, но и одиночные стартовые пробелы.
		2. Инструмент "Ёфикация текста":
			а). В базу слов добавлено "всё-таки" (баг https://sourceforge.net/p/fbtools/bugs/16/).
		3. Инструмент "Удаление всех объектов в документе":
			а). Исправлена ошибка. Теперь закладки, на которые ничто не ссылается, удаляются ВО ВСЕХ объектах: текст, таблицы, врезки, сноски и концевые сноски.
			
OOoFBTools-2.34
	А. Конвертер:
		1). Исправлен баг: При экспорте docx файлов в некоторых случаях fb2 получался невалидным из-за наличия в docx файле неотображаемых символов (https://sourceforge.net/p/fbtools/discussion/general/thread/44c9d23a/).
		2). Исправлен баг: Восстановлено отображение прогресса на стадии Анализе документа.
		3). Исправлен баг: При экспорте файла, не содержащего сносок в выходной файл всё равно пишется блок сносок (bug https://sourceforge.net/p/fbtools/bugs/20/)
	Б. Инструменты Корректировки текста:
		1. Инструмент "Корректор Текста":
			а). Исправлен баг: Если через буфер памяти вставить в Writer некоторый фрагмент текста, то Корректор не отрабатывает всех огрехов, после экспорта остаётся некоторое количество пробелов в начале абзаца (https://sourceforge.net/p/fbtools/discussion/general/thread/b2039d64/).
			б). Для опции "Заменить дефис или минус, используемый между слов вместо тире, на тире" введана обработка ситуаций, когда дефис или тире (минус игнорируется) не разделены пробелом (пробелами) с левым словом. Например, фраза "ПРОПАН– горючий газ" будет преобразована к виду "ПРОПАН — горючий газ".

OOoFBTools-2.35
	А. Конвертер:
		1). Улучшен экспорт Юникодных маркеров.
	Б. Инструменты Корректировки текста:
		1. Инструмент "Корректор Текста":
			1). Исправлен баг: Введена обработка атрибутов тире, пробелов вокруг него, и первого символа слова после тире на предмет курсива и полужирного начертания. Теперь в этих случаях 1-й символ слова имеет те же атрибуты, что и все остальные символы этого же слова.
			2). Исправлен баг для LO: Улучшено удаление неразрывных пробелов в начале абзаца, когда в тексте вместо абзаца находится разрыв строки.
			3). Исправлен баг - падение при обработке дефисов и тире.
			4). Исправлен баг: Падение Корректора в некоторых случаях при отработке опции "Заменить дефис или минус, используемый между слов вместо тире, на тире"
			5). Исправлен баг: в некоторых ситуация множественные пробелы не заменялись на выбранное число и тип пробелов.
			6). НОВАЯ группа опций "Обработка сокращений слов, единиц  веса, емкости, длины"
				а). Из Группы опций "Вставка пробелов" сюда перенесена опция "Вставить неразрывные пробелы между Фамилией и инициалами"
				б). Из Группы опций "Вставка пробелов" сюда перенесена опция "Вставить неразрывный пробел в сокращениях т.д., т.п., т.к., т.н., т.ч., т.е."
				в). НОВАЯ опция: "Обработать сокращения единиц веса, емкости, длины, количества..."
				г). НОВАЯ опция: "Обработать сокращения в почтовых адресах (ул., пос., кв. ...)"
				д). НОВАЯ опция: "Обработать окончания числительных (1900-е, 60-ые, 5-ть. ...)"
				е). НОВАЯ опция: "Обработать слова с окончаниями-числительными: Восход-1, Apollo — XIII"
				ж). НОВАЯ опция: "Обработать сокращения в документах (табл., рис., гл. ...)"
			7). Группа опций "Разное":
				а). НОВАЯ опция "Обработать °C"
				б). НОВАЯ опция "Обработать %"
				в). НОВАЯ опция "Обработать пробелы вокруг ©, ®, ™, №, §"
				г). НОВАЯ опция: "Заменить символы +/- или +- перед числом знаком ±"
				д). НОВАЯ опция: "Удалить пробелы между знаками параграфа и номера: § § => §§, № № => №№"
			8). Группа опций "Вставка пробелов":
				а). Улучшена работа опции "Вставляем пробел после знака препинания".
					1). Добавлена обработка "слипшихся" цифр, знаков препинания (кроме точки) и буквы (например, 450,и).
					2). Добавлена вставка пробела после цифры, точки и русской буквой (например, 450.А (рус)).
				б). НОВАЯ опция "Вставка пробела между русским словом и цифрой (30машин, домов25)"
			9). Группа опций "Дефисы и тире":
				а). Улучшена обработка дефисов, минусов и тире в ситуациях, когда дефис, тире или минус "прилип" к слову справа (например: вот он —пример)
		2. Инструмент "OCR ошибки форматирования":
			а). Исправлен баг обработки знаков препинания (переделан алгоритм).
			б). НОВАЯ опция: "Пробелы вокруг тире, и первый символ после него". Предназначена для обработки атрибутов тире, пробелов вокруг него, и первого символа после этого тире на предмет наличия/отсутствия курсива и полужирного.
		3. Инструмент "Генератор сносок":
			а). НОВОЕ: Добавлена возможность выбора типа генерируемых сносок: Сноски или Концевые сноски.
			
OOoFBTools-2.36
	А. Конвертер:
		1). НОВОЕ: В диалог "Настройки ExportToFB21..." введена опция "Задать описание книги по-умолчанию" (по-умолчанию отключена). Полезна для быстрого экспорта в fb2 без детального заполнения списка описания книги. Название книги, данные Автора книги потом придется исправлять на настоящие в fb2-редакторе.
	Б. Инструменты Корректировки текста:
		1. Инструмент "Корректор Текста":
			а). Исправлены ошибки в работе групп опций "Обработка сокращений слов, единиц  веса, емкости, длины"
			б). Исправлена ошибка в работе опции "Удаление пробелов перед знаком препинания", которая вносила сильные изменения в текст, дублируя куски текста.
			в). Отключение опции "Вставить пробел между русским словом и цифрой (30машин, на25)" для профилей "Научная литература", "Техническая литература". Иначе в научно-технической литературе "портятся" пробелами химичесвкие формулы, цифры-индексы,..
			г). Улучшен алгоритм работы опции "Обработать %".
		2. Инструмент "Интерактивное создание сносок":
			а). Исправлен баг: в последней версии LO разработчики изменили алгоритм удаления закладок. Это привело к тому, что инструмент перестал правильно функционировать. Исправлено.
			б). НОВОЕ: Добавлена возможность выбора типа генерируемых сносок: Сноски или Концевые сноски.
			
OOoFBTools-2.37
	А. Конвертер:
		1. Панель fb2 стилей:
			а). НОВОЕ: При загрузке панели осуществляется поиск в документе абзацев вида "***", "* * *" и форматирование их локализованным стилем "Подзаголовок".
			б). Для уменьшения размеров панели все Настройки перенесены на отдельную страницу панели. Переключение между fb2 стилями и настройками осуществляется переключателей "Стили - Настройки".
			в). Список стилей разбит на функциональные группы, каждая из которых выделена цветом для удобства работы.
		2. Схема Жанров от Либрусека дополнена новыми жанрами от Либрусека.
		3. Все Жанры всех схем приведены в полное соответствие с схемами fb2.1, Либрусек и Флибуса соответственно (исправены старые мелкие неточности).
		4. Все Жанры всех схем отсортированы по Группам, в Группах - по Алфавиту, и Группы - по алфавиту.
		5. Изменено представление всех Жанров всех схем - теперь они показаны в виде псевдодерева. Так нагляднее и легче ориентироваться.
		6. Данное изменение Жанров всех схем проведено и для локализаций, отличных от русской или украинской.
	Б. Инструменты Корректировки текста:
		1. Инструмент "Форматирование документа":
			а). НОВАЯ опция: "Убрать капитель (требуется много времени)". Обрабатывается весь документ: текст, таблицы, врезки, сноски и концевые сноски.
			
OOoFBTools-2.38
	А. Общее:
		1. Изменил старый сайт OOoFBTools на новый в описании расширения (отображается в Сервис / Управление расширениями... ).
		2. В диалог "О программе" добавл 2-х помощников: Сергей Стариков (администратор сайта) и Дмитрий Габинский (перевод на английский).
	Б. Корректор:
		1. Панель fb2 стилей:
			а). Изменены размера элементов формы ("подгонка" под LO 5).
		2. Редактор fb2 свойств:
			а). Для Custom-info увеличен список типов пользовательских данных (Обложка, Тираж и т.д.).
	В. Инструменты Корректировки текста:
		1. Инструмент "Поиск OCR ошибок в тексте..."
			а). В LO 5 этот инструмент перестал корректно работать. Исправлено.
			
OOoFBTools-2.39
	А. Корректор:
		1. Исправлен баг по обработке разрыва строки( в LO, в отличие от AOO, сломан механизм регулярных выражений по обработке разрыва строк) - https://sourceforge.net/p/fbtools/bugs/19/
		2. Опция "Обработка сокращений слов, единиц веса, емкости, длины...": Исправлен баг при вставке неразрывных пробелов в сокращениях (вставлялся неразвывный пробел и в словах, начинающихся на искомые сокращения) - (https://sourceforge.net/p/fbtools/bugs/22/)
		3. Опция "Удалить пробелы внутри кавычек": Исправил старый баг, когда пробелы не удалялись. Работает только с кавычками-ёлочками « и » (https://sourceforge.net/p/fbtools/bugs/23/)
	В. Инструменты Корректировки текста:
		1. Ёфикатор:
			а). На LO входил в бесконечный цикл из-за очередной поломки разработчиками LO механизма работы UNO структур (в AOO такого нет). Исправил.
			б). В базу Ёфикатора добавил слово "умён" (https://sourceforge.net/p/fbtools/bugs/26/).
		2. Инструмент "Поиск OCR ошибок в тексте": Для режима поиска "Обрыв абзаца на словах, знаках препинания, кавычках и скобках" введено поле для ввода знаков препинания, скобок, кавычек для поиска. Можно задавать те символы, которые нужны конкретно вам. Кнопка "Восстановить" восстанавливает набор символов в этом поле по-умолчанию. (https://sourceforge.net/p/fbtools/bugs/15/)
		ВАЖНО: Поскольку для поиска используются регулярные выражения, то перед закрывающей квадратной скобкой в поле символов обязательно должен стоять символ \ (как это задано в наборе символов по-умолчанию).
		
OOoFBTools-2.40
	А. Конвертер:
		1. Панель fb2 стилей:
			а). Добавлен стиль "Базовый".
			б). Добавлена кнопка Clear Format, для сброса форматирования абзаца безз изменения его стиля.
		2. Добавлен в список Жанров жанр "Оккультизм".
		3. Добавлен в список Жанров жанр "Археология".
		
OOoFBTools-2.41
	А. Общее:
		1. Устранена ошибка для многих инструментов по работе с текстом (переполнение), когда в тексте присутствует более 32 тыс. закладок, или гиперссылок, или сносок...
	Б. Конвертер:
		1. Исправлен баг: "падение" конвертера в случае, когда в одном абзаце есть несколько закладок, которые должны быть преобразованы в идентификаторы тега <p> для ссылки на этот абзац, и в настройках конвертера отключена опция "Удаление неиспользуемых закладок (на них ничто не ссылается) во всем Документе"
		2. Замена в идентификаторах абзаца символов, отличных от букв и цифр (название закладок в тексте содержит недорпустимые символы) на символ _. Иначе fb2 файл получался невалидным.
	В. Инструменты Корректировки текста:
		1. Инструмент "Отменить форматирование абзаца" переименован в "Сменить стиль на базовый".
		
OOoFBTools-2.42
	А. Конвертер:
		1. Исправлены ошибки в схеме жанров.
		2. Размеры панели fb2 Стилей уменьшены (новый релиз LO исправил баг, когда пользовательские панели произвольно меняли свои размеры).
	Б. Инструменты Корректировки текста:
		1. Виртуальные клавиатуры:
			а). На денежной клавиатуре добавлены кнокпи символов Российского рубля и Украинской гривны (спасибо Дмитрию (Dmitri Gabinski) ).

OOoFBTools-2.43
	А. Общее:
		1. Исправлены неточности в справке.
		2. Исправлен баг: Не восстанавливалась позиция форм всех диалогов инструментов при их запуске.
		3. Исправлено множество мелких багов в различных инструментах.
	Б. Конвертер:
		1. Исправлено неверно отображение некоторых жанров в Группах жанров.
		2. НОВАЯ опция в диалоге экспорта: Сжать fb2 файл в zip архив (.fb2.zip).
		3. Исправлен баг неверного экспорта таблиц средней сложности.
		
OOoFBTools-2.44
	А. Конвертер:
		1. НОВОЕ: Выбор расширения для zip-архива: .fb2.zip или .fbz.
		2. ИСПРАВЛЕНИЕ БАГА: Для Windows исправлен баг падения конвертера при архивации fb2 файла.
		2. ИСПРАВЛЕНИЕ БАГА: Исправлен баг падения конвертера при сохранении настроек.
		
OOoFBTools-2.45
	А. Конвертер:
		1. ИСПРАВЛЕН БАГ для Windows: При экспорте с опцией создания zip-архива создавался rar-архив, которые не все читалки могли открыть. Заменил архиватор на 7za.
		2. Для Unix систем: Улучшена генерация id книги (GUID).
		3. Для Unix систем: Введена проверка на наличие необходимых дополнительных утилит (uuidgen, zip, xmllint, base64, openssl) и выдача сообщений, если нужная утилита не установлена в системе.
		4. Для Unix систем: Экспорт картинок осуществляется либо утилитой base64, либо - openssl. Поэтому достаточно установить только одну из них.
		5. Для Unix систем: Улучшено отображение результата валидации fb2 файла.
	Б. Инструмент "Интерактивное создание сносок":
		1. В список "Шаблона для № примечания в списке" добавлен шаблон "x ...." - Номео сноски без точки.
	В. Валидатор:
		1. Для Unix симтем: Введена проверка на наличие необходимой дополнительной утилиты xmllint и выдача сообщения о необходимости ее установки, если эта утилита не установлена в системе.

OOoFBTools-2.46
	А. Конвертер:
		1. Исправлен БАГ: Если в документе есть только один вид сносок (концевые или страничные), и в Настройках выбран режим "Экспорт сносок и концевых сносок В общий блок", то текст сносок не экспортировался. Исправлено (https://sourceforge.net/p/fbtools/bugs/27/)
		2. Если созданный fb2 файл запаковывается в zip архив, то происходит удаление промежуточного fb2 файла. (https://sourceforge.net/p/fbtools/bugs/29/)
		3. Если созданный fb2 файл запаковывается в zip архив, то в выводе результата валидности указывается корректное расширение файла (https://sourceforge.net/p/fbtools/bugs/27/).
		4. Имя fb2 файла внутри zip архива сохранено с транлитерацией. (https://sourceforge.net/p/fbtools/bugs/30/)
		5. Для UNIX: При упаковке в zip fb2 файл архивировался вместе с папками, в которых он находится. Теперь в архиве находится только fb2 файл.(https://sourceforge.net/p/fbtools/bugs/30/)
		
OOoFBTools-2.47
	А. Конвертер:
		1. Панель fb2-стилей: Базовый fb2 стиль теперь имеет Название шрифта базового стиля Офиса.
		2. Исправлен БАГ: При сжатии созданного fb2 файла, если имя файла было задано латинскими символами, вылетала ошибка и архив не формировался. Исправлено (https://sourceforge.net/p/fbtools/bugs/32/)
		3. Для Nix-систем: Не требуется наличие утилиты uuidgen в системе. Генерация id книги производится средствами Python (https://sourceforge.net/p/fbtools/bugs/31/)
		4. Для Nix-систем: Не требуется наличие утилиты openssl или base64 в системе. Кодирование картинок в base64 производится средствами Python.
		5. Для Nix-систем: Не требуется наличие утилиты zip в системе. Сжатие производится средствами Python.
	Б. Инструменты Корректировки текста:
		1. Инструмент "Ёфикатор":
		а). Внесены изменения в базу данных (https://sourceforge.net/p/fbtools/bugs/25/)
		
OOoFBTools-2.48
	А. Конвертер:
		1. Настройки конвертера: НОВАЯ опция "Форматирование fb2 стилей" (по просьбе пользователей). По умолчанию выключена. При ее выключении, при загрузке fb2 стилей стили "Заголовок 1"... "Заголовок 10", "Подзаголовок" и "Базовый" имеют стандартное форматирование офиса (цвет, отступы, размер шрифта, название шрифта и т.д.). Если же включить опцию "Форматирование fb2 стилей", то форматирование этих стилей будет изменено на жестко заданное для fb2 стилей. На конвертирование оция не оказывает абсолютно никакого влияния - только на внешний вид документа.
	Б. Инструменты Корректировки текста:
		1. Корректор Текста:
			а). Исправлена некорректная работа опции "Вставка пробела между русским словом и цифрой (30машин, домов25)": Баг заключался в порче текста при наличии в нем цифр в вершнем индексе - эти цифры лишались своего индекса, что искажало тексты с формулами (степени цифр), абзацы с номерами в верхнем индексе, номера сносок в верхнем индексе в тексте... Исправлено.
			б). Исправлен баг в работе опции "Заменить минус на дефис в уточняющих словах" (https://sourceforge.net/p/fbtools/bugs/33/)
		2. Генератор сносок. Режим Теста документа :
			а). Исправлен баг: При перечислении в отчете номеров зон (закладок) по порядку, все номера были равны 0.
			б). Улучшена читабельность отчета: Теперь выводятся данные только для тех глав и списков примечаний (зоны поиска), которые требуют корректировки номеров примечаний (сносок) в тексте глав и/или в списках примечаний. Зоны поиска, номера примечаний которых не требуют корректировки, не выводятся.
			в). Улучшен алгоритм: теперь, если есть полное соответствие между номерами сносок в тексте и номерами примечаний в списках примечаний, но порядок номеров - не последовательный (например, 1, 5, 3, 2...), то Тест работает корректно. Раньше Тест отрабатывал корректно только в случае последовательного порядка номеров сносок (1, 2, 3, 4, 5...)
		2. Генератор сносок. Режим Генерации :
			а). Улучшен алгоритм: теперь, если есть полное соответствие между номерами сносок в тексте и номерами примечаний в списках примечаний, но порядок номеров - не последовательный (например, 1, 5, 3, 2...), то генерация сносок проходит корректно. Раньше генерация отрабатывала корректно только в случае последовательного порядка номеров сносок (1, 2, 3, 4, 5...)

OOoFBTools-2.49
	А. Инструменты Корректировки текста:
		1. Корректор Текста:
			а). Исправлена ошибка: "Падение" Корректора Текста на вставке пробела между словом и цифрой в сносках.
			
OOoFBTools-2.50
	1. Адаптация под LibreOffice 5.3.1.2 (https://sourceforge.net/p/fbtools/bugs/34/)
	
OOoFBTools-2.51
	А. Конвертер:
		1. Для Linux улучшен экспорт картинок.
		2. НОВОЕ: Если абзацы простого текста выровнены по центру, то тег <p> принимает вид <p style="text-align:center;"> (https://sourceforge.net/p/fbtools/enchancements/10/)
	Б. Инструменты Корректировки текста:
		1. Удаление всех объхектов в документе:
			а). НОВОЕ: Опция "Все гиперссылки". Позволяет удалять из документа все гиперссылки.
			
OOoFBTools-2.52
	А. Общее
		1. Обновлен перевод названий всех инструментов для меню и для панели инструментов (перевод Yury Tarasievich).
	Б. Инструменты Корректировки текста:
		1. Корректор Текста:
			а). Исправлен старый баг - вставка '\n' вместо спец-символа новой строки для LO (https://sourceforge.net/p/fbtools/bugs/35/).
			
OOoFBTools-2.53
	А. Конвертер:
		1. Исправлен баг: конвертер в ряде случаев "терял" данные ячеек сложных таблиц со встроенными в эти ячейки таблицами.
		2. Исправлен баг: конвертер в ряде случаев "падал" на сложных таблицах со встроенными в ячейки в эти ячейки таблицами.
		3. При запуске конвертера делается проверка на наличие в документе таблиц с вложенными в их ячейки другими таблицами. В случае их наличия выдается предупреждение, что данные вложенных таблиц игнорируются конвертером и теряются в полученном fb2 файле. Предлагается выбрать одно из 3-х действий: Продолжить конвертацию, Прервать конвертацию. Запустить интерактивный инструмент Преобразования вложенных таблиц в текст.
		4. Новое: Экспорт выравнивания абзацев по правой стороне (по центру было реализовано ранее). В диалоге Настройки введена опция включения/отключения экспорта выравнивания абзацев ("Выравнивание абзацев"). По-умолчанию отключена.
		5. Исправлен баг: падение конвертера, если в документе встречалась таблица-врезка.
	Б. Инструменты Корректировки текста:
		1. Исправлен баг: падение инструмента, если в документе встречалась таблица-врезка.
		
OOoFBTools-2.53
	А. Инструменты Корректировки текста:
		1. Корректор текста:
			а). Исправлен баг опции "Вставка пробела между русским словом и цифрой". На врезках Корректор входил в бесконечный цикл и опция не работала.
		2. Инструмент "Интерактивное создание сносок":
			а). Исправлен баг: Выделение текста примечания для примечания с номером в верхнем индексе не работало корректно: в выделение включался и номер примечания.
			б). Изменен алгоритм выделения текста примечания: Выпадающий список "Шаблон для № примечания в списке" действут теперь только для раскраски номеров примечаний в тексте и в списке примечаний (кнопка "123"). Текст примечания определяется автоматически, независимо от вида шаблона "Шаблон для № примечания в списке".
			
OOoFBTools-2.54
	А. Конвертер:
		1. Внесена совместимость с LibreOffice 6.1 (https://sourceforge.net/p/fbtools/bugs/36/)
		2. Исправлен древний баг: Если между картинок не было пустой строки, то fb2 файл получался не валидным. Теперь между картинками вставляется <empty-line />.
	Б. Инструменты Корректировки текста:
		1. Преобразовать вложенные таблицы в текст:
			а). Внесена совместимость с LibreOffice 6.1
		2. Встаивание картинок в документ:
			а). Внесена совместимость с LibreOffice 6.1
			
OOoFBTools-2.55
	А. Конвертер:
		1. На Windows сжатие в zip осуществляется zip утилитой из состава Windows.
	Б. Инструменты Корректировки текста:
		1. Корректор текста:
			а). Исправлен баг: опция "Вставка пробела между русским словом и цифрой" работает не только в тексте, но и в сносках, и в таблицах, и в врезках.
			
OOoFBTools-2.56
	А. Конвертер:
		1. Исправлен неверный алгоритм компрессии в zip для Windows. Теперь вложенные папки, в которых лежит fb2 файл, не включаются в zip файл.
		2. Исправил баг падения конвертера на векторных фигурах и картинках (https://sourceforge.net/p/fbtools/bugs/38/). Теперь снова экспортируются и все векторные фигуры, кроме линий.
		

OOoFBTools-2.57
	А. Приведение инструментов в соответствие с изменениями LibreOffice 6.4
		1. Удалено дублирование определений переменных, которое в новом офисе приводило к появлению сообщения об ошибке.
		
OOoFBTools-3.0
	А. Введена поддержка схемы жанров от библиотек CoolLib и LitVek.
	
OOoFBTools-3.1
	А. Конвертер:
		1 Исправлен баг: В диалоге fb2 свойств не сохранялась/не подгружалась настройка для схемы жанров от библиотек CoolLib и LitVek.
		2. Сделано обновление схемы жанров от библиотек CoolLib и LitVek.

OOoFBTools-3.2
	А. Конвертер:
		1. Исправлен баг неверного определения кода Жанра CollLib библиотеки.
		2. Исправлен баг неверного определения схемы Жанра для CollLib библиотеки при валидации после экспорта.
		
OOoFBTools-3.3
	А. Конвертер:
		1. Исправлен баг неверного определения кода Жанра всех схем.
		
OOoFBTools-3.4
	А. Конвертер:
		1. Сделано обновление схемы жанров от библиотек CoolLib и LitVek.

OOoFBTools-3.4.1
	А. Конвертер:
		1. Исправлен баг кодировки списка жанров от библиотек CoolLib и LitVek.
		
OOoFBTools-3.5
	А. Конвертер:
		1. Сделано обновление схемы жанров от библиотек CoolLib и LitVek.
		
OOoFBTools-3.5.1
	А. Конвертер:
		1. Изменен текущий год в диалоге 'О прпограмме'.
		
